define("$", function () {
	var a;
	(function (d) {
		var c = {
			extend : function (g, h, i) {
				for (var b in h) {
					g[b] = i ? h[b] : g.hasOwnProperty(b) ? g[b] : h[b];
				}
				return g;
			},
			getArgType : function (h, i) {
				if (arguments.length < 1) {
					return -1;
				}
				var b = typeof h, g = typeof i;
				if (b === "string" && g === "undefined") {
					return 0;
				}
				if (b === "object") {
					return 2;
				}
				if (b === "string" && (g === "string" || g === "number")) {
					return 1;
				}
				return -1;
			},
			setStyle : function (f, b, g) {
				b.indexOf("-") !== -1 && (b = b.replace(/\-[a-z]/g, function (e) {
					return e[1].toUpperCase();
				}));
				f.style[b] = g;
			},
			getStyle : function (e, b) {
				b = b.replace(/[A-Z]/g, function (f) {
					return "-" + f.toLowerCase();
				});
				return document.defaultView.getComputedStyle(e, "").getPropertyValue(b);
			},
			css : function (b, f, g) {
				return c.attrHandler(b, f, g, c.getStyle, c.setStyle);
			},
			attr : function (b, f, g) {
				return c.attrHandler(b, f, g, c.handler.attrRead, c.handler.attrWrite);
			},
			handler : {
				attrRead : function (b, e) {
					return b.getAttribute(e);
				},
				attrWrite : function (b, f, g) {
					b.setAttribute(f, g);
				}
			},
			attrHandler : function (b, i, q, t, p) {
				var r = c.getArgType(i, q), k;
				if (r === 0) {
					k = b.length >= 0 ? b[0] : b;
					return k ? t(k, i) : null;
				}
				if (b.length >= 0) {
					for (var s = 0; s < b.length; s++) {
						k = b[s];
						if (r === 2) {
							for (var n in i) {
								p(k, n, i[n]);
							}
						} else {
							p(k, i, q);
						}
					}
				} else {
					if (r === 2) {
						for (var n in i) {
							p(b, n, i[n]);
						}
					} else {
						p(b, i, q);
					}
				}
				return b;
			},
			valHooks : {
				select : {
					get : function (i) {
						var b = [], h = i.options;
						for (var g = 0; g < h.length; g++) {
							h[g].selected && b.push(h[g].value);
						}
						if (b.length == 1) {
							return b[0];
						} else {
							if (b.length == 0) {
								return null;
							} else {
								return b;
							}
						}
					},
					set : function (j, k) {
						var l = j.options, m = j.getAttribute("multiple") ? true : false;
						for (var i = 0; i < l.length; i++) {
							var b = l[i];
							b.selected = false;
							if (m) {
								a.inArray(k, b.value) && (b.selected = true);
							} else {
								if (k == b.value) {
									b.selected = true;
									return;
								}
							}
						}
					}
				}
			},
			dataset : function (b, e) {
				if (b.dataset) {
					return b.dataset[e];
				} else {
					return b.getAttribute("data-" + e);
				}
			},
			overWriteClass : function (b, f) {
				b && (b.className = f);
			},
			hasClass : function (b, f) {
				var g = " " + f + " ";
				if ((" " + b.className + " ").indexOf(g) != -1) {
					return true;
				}
				return false;
			},
			addClass : function (h, k) {
				var j = k.split(" "), b;
				b = a.trim(h.className);
				if (!h.className) {
					h.className = k;
					return;
				}
				b = " " + b + " ";
				for (var i = 0; i < j.length; i++) {
					b.indexOf(" " + j[i] + " ") == -1 && (b += j[i] + " ");
				}
				h.className = a.trim(b);
			},
			removeClass : function (b, g) {
				var f = b.className;
				f && (b.className = a.trim(f.replace(g, "").replace(/[ ]+/g, " ")));
			},
			toggleClass : function (b, e) {
				c.hasClass(b, e) ? c.removeClass(b, e) : c.addClass(b, e);
			}
		};
		a = function (b, e) {
			return new a.fn.find(b, e);
		};
		a._instance = function (b) {
			if (b && b.length) {
				for (var e = 0; e < b.length; e++) {
					this[e] = b[e];
				}
				this.length = b.length;
			}
			return this;
		};
		a._emptyArray = [];
		a.getEmptyArray = function () {
			a._emptyArray.length = 0;
			return a._emptyArray;
		};
		a.fn = a.prototype = {
			length : 0,
			selector : "",
			find : function (b, k) {
				var i = a.getEmptyArray();
				if (!b && !this.length) {
					return new a._instance();
				}
				if (b && (b.nodeType || b === window)) {
					i[0] = b;
					return new a._instance(i);
				}
				if (!k && this.length) {
					var j;
					for (var l = 0; l < this.length; l++) {
						b ? j = this[l].querySelectorAll(b) : j = this[l].childNodes;
						for (var m = 0; m < j.length; m++) {
							j[m].nodeType === 1 && i.push(j[m]);
						}
					}
				} else {
					k = k || document;
					typeof b === "string" && (i = k.querySelectorAll(b));
				}
				return new a._instance(i);
			},
			children : function (b) {
				if (this.length == 0) {
					return this;
				}
				if (b) {
					return this.find("* > " + b);
				} else {
					return this.find();
				}
			},
			parent : function () {
				if (this.length == 0) {
					return this;
				}
				var e = a.getEmptyArray();
				for (var b = 0; b < this.length; b++) {
					this[b].nodeType === 1 && e.push(this[b].parentNode);
				}
				return new a._instance(e);
			},
			each : function (e) {
				for (var b = 0; b < this.length; b++) {
					if (e.call(this[b], b, this[b]) === false) {
						break;
					}
				}
				return this;
			},
			bind : function (f, g) {
				for (var b = 0; b < this.length; b++) {
					this[b].addEventListener(f, g, false);
				}
				return this;
			},
			unbind : function (f, g) {
				for (var b = 0; b < this.length; b++) {
					this[b].removeEventListener(f, g, false);
				}
				return this;
			}
		};
		a._instance.prototype = a.fn;
		a.extend = a.fn.extend = function (f) {
			var b = f;
			typeof f === "function" && (b = f.call(null, a));
			if (!b) {
				return;
			}
			for (var g in b) {
				a.fn[g] = b[g];
			}
		};
		a.ready = function (b) {
			if (document.readyState === "complete" || document.readyState === "loaded" || document.readyState === "interactive") {
				b.call(null);
				return;
			} else {
				document.addEventListener("DOMContentLoaded", b, false);
			}
		};
		a.extend({
			html : function (f) {
				if (f === d) {
					var g = this[0];
					return g && g.nodeType === 1 ? this[0].innerHTML : null;
				}
				for (var b = 0; b < this.length; b++) {
					this[b].innerHTML = f;
				}
				return this;
			},
			text : function (b) {
				if (b === d) {
					return a.decodeHTML(this.html(b));
				}
				this.html(a.encodeHTML(b));
				return this;
			},
			val : function (h) {
				if (h === d) {
					var b = this[0];
					if (!b) {
						return null;
					}
					var g = c.valHooks[b.nodeName.toLowerCase()];
					return g ? g.get(b) : b.value;
				}
				for (var i = 0; i < this.length; i++) {
					var b = this[i], g = c.valHooks[b.nodeName.toLowerCase()];
					g ? g.set(b, h) : b.value = h;
				}
				return this;
			},
			overWriteClass : function (e) {
				for (var b = 0; b < this.length; b++) {
					c.overWriteClass(this[b], e);
				}
			},
			hasClass : function (e) {
				for (var b = 0; b < this.length; b++) {
					if (c.hasClass(this[b], e)) {
						return true;
					}
				}
				return false;
			},
			addClass : function (e) {
				for (var b = 0; b < this.length; b++) {
					c.addClass(this[b], e);
				}
				return this;
			},
			removeClass : function (e) {
				for (var b = 0; b < this.length; b++) {
					c.removeClass(this[b], e);
				}
				return this;
			},
			toggleClass : function (e) {
				for (var b = 0; b < this.length; b++) {
					c.toggleClass(this[b], e);
				}
				return this;
			},
			attr : function (b, e) {
				return c.attr(this, b, e);
			},
			css : function (b, e) {
				return c.css(this, b, e);
			},
			blur : function () {
				this[0].blur();
				return this;
			},
			focus : function () {
				this[0].focus();
				return this;
			},
			size : function () {
				return this.length;
			},
			remove : function () {
				var b;
				for (var e = 0; e < this.length; e++) {
					b = this[e];
					b.parentNode && b.parentNode.removeChild(b);
				}
				return this;
			},
			append : function (b) {
				if (b === d) {
					return this;
				}
				var g, i = b.nodeType;
				for (var h = 0; h < this.length; h++) {
					g = this[h];
					i ? g.appendChild(b) : g.innerHTML += b;
				}
				return this;
			}
		});
		a.extend({
			show : function (j) {
				var h, i, k = [];
				j = j || "block";
				for (var b = 0; b < this.length; b++) {
					h = this[b];
					i = h.style;
					i.display === "none" && (i.display = "");
					i.display === "" && c.css(h, "display") === "none" && k.push(h);
				}
				for (var b = 0; b < k.length; b++) {
					k[b].style.display = j;
				}
				return this;
			},
			hide : function () {
				for (var b = 0; b < this.length; b++) {
					this[b].style.display = "none";
				}
				return this;
			},
			visibility : function (e) {
				for (var b = 0; b < this.length; b++) {
					this[b].style.visibility = e == true ? "inherit" : "hidden";
				}
				return this;
			}
		});
		a.extend({
			dataset : function (b) {
				return c.dataset(this[0], b);
			}
		});
		a.encodeHTML = function (b) {
			return b.replace ? b.replace(/</g, "&lt;").replace(/>/g, "&gt;") : b;
		};
		a.decodeHTML = function (b) {
			return b.replace ? b.replace(/&lt;/g, "<").replace(/&gt;/g, ">") : b;
		};
		a.inArray = function (b, g) {
			if (!b.length) {
				return b == g;
			}
			for (var f = 0; f < b.length; f++) {
				if (b[f] == g) {
					return true;
				}
			}
			return false;
		};
		a.trim = function (b) {
			if (!b) {
				return "";
			}
			if (b.trim) {
				return b.trim();
			} else {
				return b.replace(/^[\s\t ]+|[\s\t ]+$/g, "");
			}
		};
		a.parseJSON = function (b) {
			if (!b) {
				return null;
			}
			typeof b !== "string" && (b = String(b));
			if (window.JSON && window.JSON.parse) {
				try {
					return window.JSON.parse(b);
				} catch (e) {
					return (new Function("return " + a.trim(b)))();
				}
			}
			return (new Function("return " + a.trim(b)))();
		};
		a.stringify = function (b) {
			if (window.JSON) {
				return JSON.stringify(b);
			}
			var k = typeof b;
			if (k != "object" || b === null) {
				k == "string" && (b = '"' + b + '"');
				return String(b);
			} else {
				var l, j, n = [], m = b && b.constructor == Array, p = arguments.callee;
				for (l in b) {
					j = b[l];
					k = typeof j;
					b.hasOwnProperty(l) && (k == "string" ? j = '"' + j + '"' : k == "object" && j !== null && (j = p(j)), n.push((m ? "" : '"' + l + '":') + String(j)));
				}
				return (m ? "[" : "{") + String(n) + (m ? "]" : "}");
			}
		};
		a.pMethod = c;
	})();
	(function () {
		var t = "tjs_views", q = t + "+=", r = ";", u = "+(", v = ")", l = 0;
		function s(b) {
			return b.replace(/\n/gm, "").replace(/"/gm, '\\"');
		}
		function n(b) {
			return b.replace(/(\W*)@(\w+)/gm, "$1tjs_data.$2");
		}
		function p(b, d) {
			if (b.length == 0) {
				return "";
			}
			var c = "";
			if (!d) {
				l === 1 ? c = '+"' + s(b) + '"' : c = q + '"' + s(b) + '"';
				l = 1;
			} else {
				var e = b.charAt(0);
				e === "=" ? (l === 1 ? c = u + n(b.substr(1)) + v : c = q + n(b.substr(1)) + r, l = 1) : (l === 1 && (c = r), c += n(b), l = 2);
			}
			return c;
		}
		function w(d) {
			var c = document.getElementById(d);
			if (c) {
				var b = c.innerHTML, e = b.indexOf("<"), f = b.lastIndexOf(">");
				return b.substring(e + 4, f - 2);
			}
			return "";
		}
		var m = a.tjs = function (c, j, i) {
			if (m[c]) {
				return m[c](j);
			}
			i = i || w;
			var d = i(c);
			if (!d) {
				return "";
			}
			l = 0;
			var b = "", e, f, k = d.length, g = "var tjs_views='';";
			for (var h = 0; h < k; h++) {
				e = d.charAt(h);
				switch (e) {
					case "[":
						f = d.charAt(++h);
						f === "%" ? (g += p(b, false), b = "") : b += e + f;
						break;
					case "]":
						f = d.charAt(h - 1);
						f === "%" ? (g += p(b.substr(0, b.length - 1), true), b = "") : b += e;
						break;
					default:
						b += e;
				}
			}
			b.length !== 0 && (g += p(b, false));
			try {
				m[c] = new Function("tjs_data", g + ";return tjs_views;");
			} catch (x) {
				"console" in window && console.log(g + ";return tjs_views;");
				throw x;
			}
			return m[c](j);
		};
	})();
	(function () {
		a.extend({
			animate : function (t, i, l, u) {
				var m = typeof i, p = typeof l, v = m === "number" ? i : 400, w = m === "string" ? i : p === "string" ? l : "linear", q = m === "function" ? i : p === "function" ? l : u, x = "all " + v + "ms " + w, r = this.length, k = this, s = function () {
					r--;
					if (r == 0) {
						for (var b = 0; b < k.length; b++) {
							k[b].style.removeProperty("-webkit-transition");
						}
						k.unbind("webkitTransitionEnd", s);
						q && q.call(k);
					}
				};
				for (var n = 0; n < this.length; n++) {
					this[n].style["-webkit-transition"] = x;
				}
				this.bind("webkitTransitionEnd", s);
				this.css(t);
			}
		});
	})();
	(function () {
		var b = {};
		a.bindHashChange = function (d, e) {
			b[d] = e;
		};
		a.bindOtherHashChange = function (c) {
			b.__all__ = c;
		};
		a.ready(function () {
			var f;
			function e() {
				var c = location.hash.match(/#([^\?]+)/);
				c && (c = c[1]);
				b[c] ? b[c].call(null, c) : b.__all__ && b.__all__.call(null, c);
			}
			function g() {
				location.hash != f && (e(), f = location.hash);
			}
			"onhashchange" in window ? (window.addEventListener("hashchange", e), e()) : window.setInterval(g, 200);
		});
	})();
	return a;
});
define("iScroll", function () {
	var a = Math, g = document, q = g.createElement("div").style, d = function () {
		var G = "t,webkitT".split(","), H, m = 0, I = G.length;
		for (; m < I; m++) {
			H = G[m] + "ransform";
			if (H in q) {
				return G[m].substr(0, G[m].length - 1);
			}
		}
		return false;
	}(), b = d ? "-" + d.toLowerCase() + "-" : "", e = f("transform"), x = f("transitionProperty"), r = f("transitionDuration"), y = f("transformOrigin"), E = f("transitionTimingFunction"), l = f("transitionDelay"), s = /android/gi.test(navigator.appVersion), t = /iphone|ipad/gi.test(navigator.appVersion), z = /hp-tablet/gi.test(navigator.appVersion), u = false, c = "ontouchstart" in window && !z, A = !!d, F = false, n = "onorientationchange" in window ? "orientationchange" : "resize", p = c ? "touchstart" : "mousedown", h = c ? "touchmove" : "mousemove", i = c ? "touchend" : "mouseup", j = c ? "touchcancel" : "mouseup", B = "mousewheel", C = function () {
		if (d === false) {
			return false;
		}
		var m = {
			"" : "transitionend",
			webkit : "webkitTransitionEnd"
		};
		return m[d];
	}(), D = function () {
		return window.requestAnimationFrame || window.webkitRequestAnimationFrame || function (m) {
			return setTimeout(m, 1);
		};
	}(), v = function () {
		return window.cancelRequestAnimationFrame || window.webkitCancelAnimationFrame || window.webkitCancelRequestAnimationFrame || clearTimeout;
	}(), k = u ? " translateZ(0)" : "", w = function (G, I) {
		var m = this, H;
		m.wrapper = typeof G == "object" ? G : g.getElementById(G);
		m.wrapper.style.overflow = "hidden";
		m.scroller = m.wrapper.children[0];
		m.options = {
			hScroll : true,
			vScroll : true,
			x : 0,
			y : 0,
			bounce : true,
			bounceLock : false,
			momentum : true,
			lockDirection : true,
			useTransform : true,
			useTransition : false,
			topOffset : 0,
			checkDOMChanges : false,
			handleClick : true,
			hScrollbar : true,
			vScrollbar : true,
			fixedScrollbar : s,
			hideScrollbar : t,
			fadeScrollbar : t && u,
			scrollbarClass : "",
			zoom : false,
			zoomMin : 1,
			zoomMax : 4,
			doubleTapZoom : 2,
			wheelAction : "scroll",
			snap : false,
			snapThreshold : 1,
			onRefresh : null,
			onBeforeScrollStart : null,
			onScrollStart : null,
			onBeforeScrollMove : null,
			onScrollMove : null,
			onBeforeScrollEnd : null,
			onScrollEnd : null,
			onTouchEnd : null,
			onInit : null
		};
		for (H in I) {
			m.options[H] = I[H];
		}
		m.x = m.options.x;
		m.y = m.options.y;
		m.options.useTransform = true;
		m.options.useTransition = false;
		m.options.hScrollbar = m.options.hScroll && m.options.hScrollbar;
		m.options.vScrollbar = m.options.vScroll && m.options.vScrollbar;
		m.scroller.style[x] = m.options.useTransform ? b + "transform" : "top left";
		m.scroller.style[r] = "0";
		m.scroller.style[y] = "0 0";
		m.options.useTransform ? m.scroller.style[e] = "translate(" + m.x + "px," + m.y + "px)" + k : m.scroller.style.cssText += ";position:absolute;top:" + m.y + "px;left:" + m.x + "px";
		m.refresh();
		m._bind(n, window);
		m._bind(p);
		m.options.checkDOMChanges && (m.checkDOMTime = setInterval(function () {
			m._checkDOMChanges();
		}, 500));
		m.options.onInit && m.options.onInit.call(m);
	};
	w.prototype = {
		enabled : true,
		x : 0,
		y : 0,
		steps : [],
		scale : 1,
		currPageX : 0,
		currPageY : 0,
		pagesX : [],
		pagesY : [],
		aniTime : null,
		wheelZoomCount : 0,
		handleEvent : function (m) {
			var G = this;
			switch (m.type) {
				case p:
					if (!c && m.button !== 0) {
						return;
					}
					G._start(m);
					break;
				case h:
					G._move(m);
					break;
				case i:
				case j:
					G._end(m);
					break;
				case n:
					G._resize();
					break;
				case C:
					G._transitionEnd(m);
					break;
			}
		},
		_checkDOMChanges : function () {
			if (this.moved || this.zoomed || this.animating || this.scrollerW == this.scroller.offsetWidth * this.scale && this.scrollerH == this.scroller.offsetHeight * this.scale) {
				return;
			}
			this.refresh();
		},
		_scrollbar : function (G) {
			var m = this, H;
			if (!m[G + "Scrollbar"]) {
				m[G + "ScrollbarWrapper"] && (A && (m[G + "ScrollbarIndicator"].style[e] = ""), m[G + "ScrollbarWrapper"].parentNode.removeChild(m[G + "ScrollbarWrapper"]), m[G + "ScrollbarWrapper"] = null, m[G + "ScrollbarIndicator"] = null);
				return;
			}
			!m[G + "ScrollbarWrapper"] && (H = g.createElement("div"), m.options.scrollbarClass ? H.className = m.options.scrollbarClass + G.toUpperCase() : H.style.cssText = "position:absolute;z-index:100;" + (G == "h" ? "height:7px;bottom:1px;left:2px;right:" + (m.vScrollbar ? "7" : "2") + "px" : "width:7px;bottom:" + (m.hScrollbar ? "7" : "2") + "px;top:2px;right:1px"), H.style.cssText += ";pointer-events:none;" + b + "transition-property:opacity;" + b + "transition-duration:" + (m.options.fadeScrollbar ? "350ms" : "0") + ";overflow:hidden;opacity:" + (m.options.hideScrollbar ? "0" : "1"), m.wrapper.appendChild(H), m[G + "ScrollbarWrapper"] = H, H = g.createElement("div"), !m.options.scrollbarClass && (H.style.cssText = "position:absolute;z-index:100;background:rgba(0,0,0,0.5);border:1px solid rgba(255,255,255,0.9);" + b + "background-clip:padding-box;" + b + "box-sizing:border-box;" + (G == "h" ? "height:100%" : "width:100%") + ";" + b + "border-radius:3px;border-radius:3px"), H.style.cssText += ";pointer-events:none;" + b + "transition-property:" + b + "transform;" + b + "transition-timing-function:cubic-bezier(0.33,0.66,0.66,1);" + b + "transition-duration:0;" + b + "transform: translate(0,0)" + k, m.options.useTransition && (H.style.cssText += ";" + b + "transition-timing-function:cubic-bezier(0.33,0.66,0.66,1)"), m[G + "ScrollbarWrapper"].appendChild(H), m[G + "ScrollbarIndicator"] = H);
			G == "h" ? (m.hScrollbarSize = m.hScrollbarWrapper.clientWidth, m.hScrollbarIndicatorSize = a.max(a.round(m.hScrollbarSize * m.hScrollbarSize / m.scrollerW), 8), m.hScrollbarIndicator.style.width = m.hScrollbarIndicatorSize + "px", m.hScrollbarMaxScroll = m.hScrollbarSize - m.hScrollbarIndicatorSize, m.hScrollbarProp = m.hScrollbarMaxScroll / m.maxScrollX) : (m.vScrollbarSize = m.vScrollbarWrapper.clientHeight, m.vScrollbarIndicatorSize = a.max(a.round(m.vScrollbarSize * m.vScrollbarSize / m.scrollerH), 8), m.vScrollbarIndicator.style.height = m.vScrollbarIndicatorSize + "px", m.vScrollbarMaxScroll = m.vScrollbarSize - m.vScrollbarIndicatorSize, m.vScrollbarProp = m.vScrollbarMaxScroll / m.maxScrollY);
			m._scrollbarPos(G, true);
		},
		_resize : function () {
			var m = this;
			setTimeout(function () {
				m.refresh();
			}, s ? 200 : 0);
		},
		_pos : function (m, G) {
			m = this.hScroll ? m : 0;
			G = this.vScroll ? G : 0;
			this.scroller.style[e] = "translate(" + m + "px," + G + "px) scale(" + this.scale + ")" + k;
			this.x = m;
			this.y = G;
			this._scrollbarPos("h");
			this._scrollbarPos("v");
		},
		_scrollbarPos : function (G, J) {
			var m = this, H = G == "h" ? m.x : m.y, I;
			if (!m[G + "Scrollbar"]) {
				return;
			}
			H = m[G + "ScrollbarProp"] * H;
			H < 0 ? (!m.options.fixedScrollbar && (I = m[G + "ScrollbarIndicatorSize"] + a.round(H * 3), I < 8 && (I = 8), m[G + "ScrollbarIndicator"].style[G == "h" ? "width" : "height"] = I + "px"), H = 0) : H > m[G + "ScrollbarMaxScroll"] && (!m.options.fixedScrollbar ? (I = m[G + "ScrollbarIndicatorSize"] - a.round((H - m[G + "ScrollbarMaxScroll"]) * 3), I < 8 && (I = 8), m[G + "ScrollbarIndicator"].style[G == "h" ? "width" : "height"] = I + "px", H = m[G + "ScrollbarMaxScroll"] + (m[G + "ScrollbarIndicatorSize"] - I)) : H = m[G + "ScrollbarMaxScroll"]);
			m[G + "ScrollbarWrapper"].style[l] = "0";
			m[G + "ScrollbarWrapper"].style.opacity = J && m.options.hideScrollbar ? "0" : "1";
			m[G + "ScrollbarIndicator"].style[e] = "translate(" + (G == "h" ? H + "px,0)" : "0," + H + "px)") + k;
		},
		_start : function (G) {
			var m = this, K = c ? G.touches[0] : G, H, I, J, L, M;
			if (!m.enabled) {
				return;
			}
			m.options.onBeforeScrollStart && m.options.onBeforeScrollStart.call(m, G);
			m.moved = false;
			m.animating = false;
			m.zoomed = false;
			m.distX = 0;
			m.distY = 0;
			m.absDistX = 0;
			m.absDistY = 0;
			m.dirX = 0;
			m.dirY = 0;
			m.options.momentum && (H = getComputedStyle(m.scroller, null)[e].replace(/[^0-9\-.,]/g, "").split(","), I = +H[4], J = +H[5], (I != m.x || J != m.y) && (v(m.aniTime), m.steps = [], m._pos(I, J), m.options.onScrollEnd && m.options.onScrollEnd.call(m, G)));
			m.absStartX = m.x;
			m.absStartY = m.y;
			m.startX = m.x;
			m.startY = m.y;
			m.pointX = K.pageX;
			m.pointY = K.pageY;
			m.startTime = G.timeStamp || Date.now();
			m.options.onScrollStart && m.options.onScrollStart.call(m, G);
			m._bind(h, window);
			m._bind(i, window);
			m._bind(j, window);
		},
		_move : function (I) {
			var m = this, L = c ? I.touches[0] : I, G = L.pageX - m.pointX, H = L.pageY - m.pointY, J = m.x + G, K = m.y + H, N, O, P, M = I.timeStamp || Date.now();
			m.options.onBeforeScrollMove && m.options.onBeforeScrollMove.call(m, I);
			(m.hScroll && Math.abs(G) > Math.abs(H) || m.vScroll && Math.abs(G) < Math.abs(H)) && I.preventDefault();
			m.pointX = L.pageX;
			m.pointY = L.pageY;
			(J > 0 || J < m.maxScrollX) && (J = m.options.bounce ? m.x + G / 2 : J >= 0 || m.maxScrollX >= 0 ? 0 : m.maxScrollX);
			(K > m.minScrollY || K < m.maxScrollY) && (K = m.options.bounce ? m.y + H / 2 : K >= m.minScrollY || m.maxScrollY >= 0 ? m.minScrollY : m.maxScrollY);
			m.distX += G;
			m.distY += H;
			m.absDistX = a.abs(m.distX);
			m.absDistY = a.abs(m.distY);
			if (m.absDistX < 6 && m.absDistY < 6) {
				return;
			}
			m.options.lockDirection && (m.absDistX > m.absDistY + 5 ? (K = m.y, H = 0) : m.absDistY > m.absDistX + 5 && (J = m.x, G = 0));
			m.moved = true;
			m._pos(J, K);
			m.dirX = G > 0 ? -1 : G < 0 ? 1 : 0;
			m.dirY = H > 0 ? -1 : H < 0 ? 1 : 0;
			M - m.startTime > 300 && (m.startTime = M, m.startX = m.x, m.startY = m.y);
			m.options.onScrollMove && m.options.onScrollMove.call(m, I);
		},
		_end : function (G) {
			if (c && G.touches.length !== 0) {
				return;
			}
			var m = this, N = c ? G.changedTouches[0] : G, K, O, L = {
				dist : 0,
				time : 0
			}, M = {
				dist : 0,
				time : 0
			}, S = (G.timeStamp || Date.now()) - m.startTime, H = m.x, I = m.y, P, Q, R, J, T;
			m._unbind(h, window);
			m._unbind(i, window);
			m._unbind(j, window);
			m.options.onBeforeScrollEnd && m.options.onBeforeScrollEnd.call(m, G);
			if (!m.moved) {
				c && this.options.handleClick && (m.doubleTapTimer = setTimeout(function () {
					m.doubleTapTimer = null;
					K = N.target;
					while (K.nodeType != 1) {
						K = K.parentNode;
					}
					K.tagName != "SELECT" && K.tagName != "INPUT" && K.tagName != "TEXTAREA" && (O = g.createEvent("MouseEvents"), O.initMouseEvent("click", true, true, G.view, 1, N.screenX, N.screenY, N.clientX, N.clientY, G.ctrlKey, G.altKey, G.shiftKey, G.metaKey, 0, null), O._fake = true, K.dispatchEvent(O));
				}, m.options.zoom ? 250 : 0));
				m._resetPos(400);
				m.options.onTouchEnd && m.options.onTouchEnd.call(m, G);
				return;
			}
			S < 300 && m.options.momentum && (L = H ? m._momentum(H - m.startX, S, -m.x, m.scrollerW - m.wrapperW + m.x, m.options.bounce ? m.wrapperW : 0) : L, M = I ? m._momentum(I - m.startY, S, -m.y, m.maxScrollY < 0 ? m.scrollerH - m.wrapperH + m.y - m.minScrollY : 0, m.options.bounce ? m.wrapperH : 0) : M, H = m.x + L.dist, I = m.y + M.dist, (m.x > 0 && H > 0 || m.x < m.maxScrollX && H < m.maxScrollX) && (L = {
				dist : 0,
				time : 0
			}), (m.y > m.minScrollY && I > m.minScrollY || m.y < m.maxScrollY && I < m.maxScrollY) && (M = {
				dist : 0,
				time : 0
			}));
			if (L.dist || M.dist) {
				R = a.max(a.max(L.time, M.time), 10);
				m.options.snap && (P = H - m.absStartX, Q = I - m.absStartY, a.abs(P) < m.options.snapThreshold && a.abs(Q) < m.options.snapThreshold ? m.scrollTo(m.absStartX, m.absStartY, 200) : (J = m._snap(H, I), H = J.x, I = J.y, R = a.max(J.time, R)));
				m.scrollTo(a.round(H), a.round(I), R);
				m.options.onTouchEnd && m.options.onTouchEnd.call(m, G);
				return;
			}
			if (m.options.snap) {
				P = H - m.absStartX;
				Q = I - m.absStartY;
				a.abs(P) < m.options.snapThreshold && a.abs(Q) < m.options.snapThreshold ? m.scrollTo(m.absStartX, m.absStartY, 200) : (J = m._snap(m.x, m.y), (J.x != m.x || J.y != m.y) && m.scrollTo(J.x, J.y, J.time));
				m.options.onTouchEnd && m.options.onTouchEnd.call(m, G);
				return;
			}
			m._resetPos(200);
			m.options.onTouchEnd && m.options.onTouchEnd.call(m, G);
		},
		_resetPos : function (I) {
			var m = this, G = m.x >= 0 ? 0 : m.x < m.maxScrollX ? m.maxScrollX : m.x, H = m.y >= m.minScrollY || m.maxScrollY > 0 ? m.minScrollY : m.y < m.maxScrollY ? m.maxScrollY : m.y;
			if (G == m.x && H == m.y) {
				m.moved && (m.moved = false, m.options.onScrollEnd && m.options.onScrollEnd.call(m));
				m.hScrollbar && m.options.hideScrollbar && (d == "webkit" && (m.hScrollbarWrapper.style[l] = "300ms"), m.hScrollbarWrapper.style.opacity = "0");
				m.vScrollbar && m.options.hideScrollbar && (d == "webkit" && (m.vScrollbarWrapper.style[l] = "300ms"), m.vScrollbarWrapper.style.opacity = "0");
				return;
			}
			m.scrollTo(G, H, I || 0);
		},
		_startAni : function () {
			var m = this, H = m.x, I = m.y, L = Date.now(), G, J, K;
			if (m.animating) {
				return;
			}
			if (!m.steps.length) {
				m._resetPos(400);
				return;
			}
			G = m.steps.shift();
			G.x == H && G.y == I && (G.time = 0);
			m.animating = true;
			m.moved = true;
			K = function () {
				var M = Date.now(), N, O;
				if (M >= L + G.time) {
					m._pos(G.x, G.y);
					m.animating = false;
					m.options.onAnimationEnd && m.options.onAnimationEnd.call(m);
					m._startAni();
					return;
				}
				M = (M - L) / G.time - 1;
				J = a.sqrt(1 - M * M);
				N = (G.x - H) * J + H;
				O = (G.y - I) * J + I;
				m._pos(N, O);
				m.animating && (m.aniTime = D(K));
			};
			K();
		},
		_momentum : function (J, O, H, I, M) {
			var K = 0.0006, G = a.abs(J) / O, m = G * G / (2 * K), N = 0, L = 0;
			J > 0 && m > H ? (L = M / (6 / (m / G * K)), H = H + L, G = G * H / m, m = H) : J < 0 && m > I && (L = M / (6 / (m / G * K)), I = I + L, G = G * I / m, m = I);
			m = m * (J < 0 ? -1 : 1);
			N = G / K;
			return {
				dist : m,
				time : a.round(N)
			};
		},
		_offset : function (m) {
			var G = -m.offsetLeft, H = -m.offsetTop;
			while (m = m.offsetParent) {
				G -= m.offsetLeft;
				H -= m.offsetTop;
			}
			return {
				left : G,
				top : H
			};
		},
		_snap : function (I, J) {
			var m = this, H, M, G, N, K, L;
			G = m.pagesX.length - 1;
			for (H = 0, M = m.pagesX.length; H < M; H++) {
				if (I >= m.pagesX[H]) {
					G = H;
					break;
				}
			}
			G == m.currPageX && G > 0 && m.dirX < 0 && G--;
			I = m.pagesX[G];
			K = a.abs(I - m.pagesX[m.currPageX]);
			K = K ? a.abs(m.x - I) / K * 500 : 0;
			m.currPageX = G;
			G = m.pagesY.length - 1;
			for (H = 0; H < G; H++) {
				if (J >= m.pagesY[H]) {
					G = H;
					break;
				}
			}
			G == m.currPageY && G > 0 && m.dirY < 0 && G--;
			J = m.pagesY[G];
			L = a.abs(J - m.pagesY[m.currPageY]);
			L = L ? a.abs(m.y - J) / L * 500 : 0;
			m.currPageY = G;
			N = a.round(a.max(K, L)) || 200;
			return {
				x : I,
				y : J,
				time : N
			};
		},
		_bind : function (m, G, H) {
			(G || this.scroller).addEventListener(m, this, !!H);
		},
		_unbind : function (m, G, H) {
			(G || this.scroller).removeEventListener(m, this, !!H);
		},
		destroy : function () {
			var m = this;
			m.scroller.style[e] = "";
			m.hScrollbar = false;
			m.vScrollbar = false;
			m._scrollbar("h");
			m._scrollbar("v");
			m._unbind(n, window);
			m._unbind(p);
			m._unbind(h, window);
			m._unbind(i, window);
			m._unbind(j, window);
			!m.options.hasTouch && m._unbind(B);
			m.options.checkDOMChanges && clearInterval(m.checkDOMTime);
			m.options.onDestroy && m.options.onDestroy.call(m);
		},
		refresh : function () {
			var m = this, J, H, L, K, G = 0, I = 0;
			m.scale < m.options.zoomMin && (m.scale = m.options.zoomMin);
			m.wrapperW = m.wrapper.clientWidth || 1;
			m.wrapperH = m.wrapper.clientHeight || 1;
			m.minScrollY = -m.options.topOffset || 0;
			m.scrollerW = a.round(m.scroller.offsetWidth * m.scale);
			m.scrollerH = a.round((m.scroller.offsetHeight + m.minScrollY) * m.scale);
			m.maxScrollX = m.wrapperW - m.scrollerW;
			m.maxScrollY = m.wrapperH - m.scrollerH + m.minScrollY;
			m.dirX = 0;
			m.dirY = 0;
			m.options.onRefresh && m.options.onRefresh.call(m);
			m.hScroll = m.options.hScroll && m.maxScrollX < 0;
			m.vScroll = m.options.vScroll && (!m.options.bounceLock && !m.hScroll || m.scrollerH > m.wrapperH);
			m.hScrollbar = m.hScroll && m.options.hScrollbar;
			m.vScrollbar = m.vScroll && m.options.vScrollbar && m.scrollerH > m.wrapperH;
			J = m._offset(m.wrapper);
			m.wrapperOffsetLeft = -J.left;
			m.wrapperOffsetTop = -J.top;
			if (typeof m.options.snap == "string") {
				m.pagesX = [];
				m.pagesY = [];
				K = m.scroller.querySelectorAll(m.options.snap);
				for (H = 0, L = K.length; H < L; H++) {
					G = m._offset(K[H]);
					G.left += m.wrapperOffsetLeft;
					G.top += m.wrapperOffsetTop;
					m.pagesX[H] = G.left < m.maxScrollX ? m.maxScrollX : G.left * m.scale;
					m.pagesY[H] = G.top < m.maxScrollY ? m.maxScrollY : G.top * m.scale;
				}
			} else if (m.options.snap) {
				m.pagesX = [];
				while (G >= m.maxScrollX) {
					m.pagesX[I] = G;
					G = G - m.wrapperW;
					I++;
				}
				m.maxScrollX % m.wrapperW && (m.pagesX[m.pagesX.length] = m.maxScrollX - m.pagesX[m.pagesX.length - 1] + m.pagesX[m.pagesX.length - 1]);
				G = 0;
				I = 0;
				m.pagesY = [];
				while (G >= m.maxScrollY) {
					m.pagesY[I] = G;
					G = G - m.wrapperH;
					I++;
				}
				m.maxScrollY % m.wrapperH && (m.pagesY[m.pagesY.length] = m.maxScrollY - m.pagesY[m.pagesY.length - 1] + m.pagesY[m.pagesY.length - 1]);
			}
			m._scrollbar("h");
			m._scrollbar("v");
			m.scroller.style[r] = "0";
			m._resetPos(400);
		},
		scrollTo : function (I, K, L, M) {
			var H = this, m = I, G, J;
			H.stop();
			!m.length && (m = [{
				x : I,
				y : K,
				time : L,
				relative : M
			}]);
			for (G = 0, J = m.length; G < J; G++) {
				m[G].relative && (m[G].x = H.x - m[G].x, m[G].y = H.y - m[G].y);
				H.steps.push({
					x : m[G].x,
					y : m[G].y,
					time : m[G].time || 0
				});
			}
			H._startAni();
		},
		scrollToElement : function (H, I) {
			var G = this, m;
			H = H.nodeType ? H : G.scroller.querySelector(H);
			if (!H) {
				return;
			}
			m = G._offset(H);
			m.left += G.wrapperOffsetLeft;
			m.top += G.wrapperOffsetTop;
			m.left = m.left > 0 ? 0 : m.left < G.maxScrollX ? G.maxScrollX : m.left;
			m.top = m.top > G.minScrollY ? G.minScrollY : m.top < G.maxScrollY ? G.maxScrollY : m.top;
			I = I === undefined ? a.max(a.abs(m.left) * 2, a.abs(m.top) * 2) : I;
			G.scrollTo(m.left, m.top, I);
		},
		scrollToPage : function (G, H, K) {
			var m = this, I, J;
			K = K === undefined ? 400 : K;
			m.options.onScrollStart && m.options.onScrollStart.call(m);
			m.options.snap ? (G = G == "next" ? m.currPageX + 1 : G == "prev" ? m.currPageX - 1 : G, H = H == "next" ? m.currPageY + 1 : H == "prev" ? m.currPageY - 1 : H, G = G < 0 ? 0 : G > m.pagesX.length - 1 ? m.pagesX.length - 1 : G, H = H < 0 ? 0 : H > m.pagesY.length - 1 ? m.pagesY.length - 1 : H, m.currPageX = G, m.currPageY = H, I = m.pagesX[G], J = m.pagesY[H]) : (I = -m.wrapperW * G, J = -m.wrapperH * H, I < m.maxScrollX && (I = m.maxScrollX), J < m.maxScrollY && (J = m.maxScrollY));
			m.scrollTo(I, J, K);
		},
		stop : function () {
			v(this.aniTime);
			this.steps = [];
			this.moved = false;
			this.animating = false;
		}
	};
	function f(m) {
		if (d === "") {
			return m;
		}
		m = m.charAt(0).toUpperCase() + m.substr(1);
		return d + m;
	}
	q = null;
	return w;
});
define("Str", function () {
	var a = {
		RegExps : {
			cut : /[\x00-\xFF]/,
			getRealLen : {
				r0 : /[^\x00-\xFF]/g,
				r1 : /[\x00-\xFF]/g
			},
			escHTML : {
				re_amp : /&/g,
				re_lt : /</g,
				re_gt : />/g,
				re_apos : /'/g,
				re_quot : /"/g
			},
			escString : {
				bsls : /\\/g,
				sls : /\//g,
				nl : /\n/g,
				rt : /\r/g,
				tab : /\t/g
			},
			restXHTML : {
				re_amp : /&amp;/g,
				re_lt : /&lt;/g,
				re_gt : /&gt;/g,
				re_apos : /&(?:apos|#0?39);/g,
				re_quot : /&quot;/g
			}
		},
		cut : function (b, d, e) {
			b = String(b);
			d -= 0;
			e = e || "";
			if (isNaN(d)) {
				return b;
			}
			var f = b.length, c = Math.min(Math.floor(d / 2), f), g = a.getRealLen(b.slice(0, c));
			for (; c < f && g < d; c++) {
				g += 1 + (b.charCodeAt(c) > 255);
			}
			return b.slice(0, g > d ? c - 1 : c) + (c < f ? e : "");
		},
		cutRealLen : function (b, c, d) {
			if (a.getRealLen(b) > c) {
				return a.cut(b, c - a.getRealLen(d), d);
			}
			return b;
		},
		getRealLen : function (b, d) {
			if (typeof b != "string") {
				return 0;
			}
			if (!d) {
				return b.replace(a.RegExps.getRealLen.r0, "**").length;
			} else {
				var c = b.replace(a.RegExps.getRealLen.r1, "");
				return b.length - c.length + encodeURI(c).length / 3;
			}
		},
		escString : function (d) {
			var b = a.RegExps.escString, c = a.RegExps.escHTML;
			return a.listReplace(d + "", {
				"\\\\" : b.bsls,
				"\\n" : b.nl,
				"" : b.rt,
				"\\t" : b.tab,
				"\\/" : b.sls,
				"\\'" : c.re_apos,
				'\\"' : c.re_quot
			});
		},
		escHTML : function (c) {
			var b = a.RegExps.escHTML;
			return a.listReplace(c + "", {
				"&amp;" : b.re_amp,
				"&lt;" : b.re_lt,
				"&gt;" : b.re_gt,
				"&#039;" : b.re_apos,
				"&quot;" : b.re_quot
			});
		},
		escRegExp : function (b) {
			return b.replace(/([\\\^\$\(\)\[\]\{\}\*\+\.\?\/\|])/g, "\\$1");
		},
		reEscHTML : function (c) {
			var b = a.RegExps.restXHTML;
			return a.listReplace(c + "", {
				"<" : b.re_lt,
				">" : b.re_gt,
				"\x27" : b.re_apos,
				"\x22" : b.re_quot,
				"&" : b.re_amp
			});
		},
		listReplace : function (b, c, d) {
			if (require("Type").isObject(c)) {
				require("Util").each(c, function (e, f) {
					b = b.replace(e, f);
				});
				return b;
			} else {
				return b.replace(c, d);
			}
		},
		tmpl : function (f, d) {
			d = d || {};
			var c = ["var __=[];"], e = /([\s\S]*?)(?:(?:<%([^=][\s\S]*?)%>)|(?:<%=([\s\S]+?)%>)|$)/g;
			e.lastIndex = 0;
			var b = e.exec(f || "");
			while (b && (b[1] || b[2] || b[3])) {
				b[1] && c.push("__.push('", b[1].replace(/\\/g, "\\\\").replace(/\n/g, "\\n").replace(/\r/g, "").replace(/\t/g, "\t").replace(/\//g, "\\/").replace(/'/g, "\\'").replace(/"/g, '\\"'), "');");
				b[2] && c.push(b[2]);
				b[3] && c.push("__.push(", b[3], ");");
				b = e.exec(f);
			}
			c.push("return __.join('');");
			var g = [], h = [];
			for (var i in d) {
				g.push(i);
				h.push(d[i]);
			}
			c = new Function(g.join(","), c.join(""));
			return c.apply(null, h);
		},
		trim : function (b) {
			return b.replace(/^\s+|\s+$/g, "");
		},
		escDescHTML : function (b, c) {
			if (b) {
				switch (c) {
					case 0:
						b = b.replace(/<[!\/]?[\w-]+[^>]*>/g, "");
						break;
					case 1:
						b = b.replace(/<[!\/]?(?!br\b|p\b)[\w-]+[^>]*>/g, "");
						break;
				}
				return b;
			}
		}
	};
	return a;
});
define("Type", function () {
	var a = {
		is : function (c, b) {
			var d = Object.prototype.toString.call(b).slice(8, -1);
			return b !== undefined && b !== null && d === c;
		},
		isNumber : function (b) {
			return a.is("Number", b);
		},
		isString : function (b) {
			return a.is("String", b);
		},
		isFunction : function (b) {
			return a.is("Function", b);
		},
		isObject : function (b) {
			return a.is("Object", b);
		},
		isArray : function (b) {
			return a.is("Array", b);
		},
		isBoolean : function (b) {
			return a.is("Boolean", b);
		}
	};
	return a;
});
define("Util", function () {
	var a = {
		extend : function (b, c) {
			if (!b) {
				return c;
			}
			for (var d in c) {
				b[d] = c[d];
			}
			return b;
		},
		each : function (b, d) {
			if (!b) {
				return false;
			}
			var e, f = 0;
			if (require("Type").isObject(b)) {
				for (var c in b) {
					if (d.call(b[c], b[c], c, b) === false) {
						break;
					}
				}
			} else {
				require("Type").isArray(b) && b.forEach(function (g, h) {
					d.call(g, g, h, b);
				});
			}
			return b;
		},
		log : function () {
			require("Const").debug && window.console && console.log.apply(console, arguments);
		},
		logError : function (b) {
			a.log(b.name + " : " + b.message + " \n stack :" + b.stack, b);
		},
		emptyFun : function () {
		},
		getUrlParam : function (e, f, b) {
			var g = new RegExp("[?#&]" + e + "=([^&#]*)", "i"), b = b || window.location.href, d = g.exec(b), c = d ? d[1] : "";
			c = c.replace(/[+]/ig, "%20");
			return !f ? decodeURIComponent(c) : c;
		},
		formatUsercount : function (b) {
			b = parseInt(b, 10);
			!isNaN(b) && (b >= 1e8 ? b = Math.round(b / 1e8) + "亿" : b < 1e8 && b >= 1e4 ? b = Math.round(b / 1e4) + "万" : b = b + "个");
			return b || 0;
		},
		delegate : function (b, g, e, d, c) {
			var f = require("$");
			b = f(b)[0];
			var h = function (k) {
				if (d && f(b).find(d)) {
					var i = Element.prototype, l = null, m = i.matchesSelector || i.mozMatchesSelector || i.webkitMatchesSelector || i.msMatchesSelector || i.oMatchesSelector, j = k.target;
					while (j != b) {
						if (m.call(j, d)) {
							l = j;
							break;
						}
						j = j.parentNode;
					}
					l && e.apply(l, [k].concat(require("Type").isArray(c) && [c]));
				} else {
					return e.apply(k.target, [k].concat(require("Type").isArray(c) && [c]));
				}
			};
			b.addEventListener(g, h, false);
		},
		addToArray : function (b, c, d) {
			if (require("Type").isArray(b)) {
				c = [].concat(c);
				a.each(c, function (e) {
					var f = b.indexOf(e);
					!(-1 < f) && (!d ? b.push(e) : b.unshift(e));
				});
				return b;
			}
			return false;
		},
		removeFromArray : function (b, c) {
			if (require("Type").isArray(b)) {
				c = [].concat(c);
				a.each(c, function (e) {
					var d = b.indexOf(e);
					-1 < d && b.splice(d, 1);
				});
				return b;
			}
			return false;
		},
		formatTime : function (e) {
			var c = parseInt((window.__responedTime - e) / 1e3), d = new Date(), b = new Date(e);
			if (c < 60) {
				return "刚刚";
			}
			if (c < 60 * 60) {
				return parseInt(c / 60) + "分钟前";
			}
			if (c < 60 * 60 * 3) {
				return parseInt(c / (60 * 60)) + "小时前";
			}
			if (d.getDate() === b.getDate()) {
				return "今天 " + b.getHours() + ":" + (b.getMinutes() < 10 ? "0" : "") + b.getMinutes();
			}
			if (new Date(d.getTime() - 24 * 60 * 60 * 1e3).getDate() === b.getDate()) {
				return "昨天 " + b.getHours() + ":" + (b.getMinutes() < 10 ? "0" : "") + b.getMinutes();
			}
			if (d.getFullYear() === b.getFullYear()) {
				return b.getMonth() + 1 + "月" + b.getDate() + "日";
			}
			return b.getFullYear() + "年" + (b.getMonth() + 1) + "月" + b.getDate() + "日";
		},
		hash : function (d) {
			var b = 5381;
			for (var c = 0, e = d.length; c < e; ++c) {
				b += (b << 5) + d.charCodeAt(c);
			}
			return b & 2147483647;
		}
	};
	return a;
});
define("Events", function (c, b) {
	var a = function () {
		this.listeners = {};
	};
	a.prototype = {
		on : function (d, e) {
			!this.listeners[d] && (this.listeners[d] = []);
			this.listeners[d].push(e);
		},
		clear : function (d) {
			this.listeners[d] && (this.listeners[d] = []);
		},
		emit : function (d) {
			try {
				!this.listeners[d] && (this.listeners[d] = []);
				var f = this.listeners[d], h = f.length, g = Array.prototype.slice.call(arguments, 1);
				f.forEach(function (e) {
					e.apply(null, g);
				});
			} catch (i) {
			}
		}
	};
	b.eventEmitter = a;
});
define("TapEvent", function () {
	var b = document.body;
	function i(k) {
		return "tagName" in k ? k : k.parentNode;
	}
	function c(k, l, m, n) {
		k.addEventListener(l, m, n);
	}
	function j(k) {
		while (k && k != b) {
			var l = k.ontap;
			if (l instanceof Function) {
				return {
					onTap : l,
					scope : k
				};
			}
			l = k.getAttribute("ontap");
			if (l) {
				return {
					onTap : new Function("event", l),
					scope : k
				};
			}
			k = k.parentNode;
		}
	}
	function g(l, k, m) {
		if (!("defaultPrevented" in k)) {
			k.defaultPrevented = false;
			var n = k.preventDefault;
			k.preventDefault = function () {
				this.defaultPrevented = true;
				n.call(this);
			};
		}
		k.data = m;
		l.dispatchEvent(k);
	}
	function h(p, k) {
		var m = document.createEvent("Events"), n = true;
		if (k) {
			for (var l in k) {
				l == "bubbles" ? n = !!k[l] : m[l] = k[l];
			}
		}
		m.initEvent(p, n, true, null, null, null, null, null, null, null, null, null, null, null, null);
		return m;
	}
	var a = {}, e, d = "";
	function f() {
		e && clearTimeout(e);
		e = null;
		a = {};
	}
	c(b, "touchstart", function (k) {
		a.el = i(k.touches[0].target);
		a.x1 = k.touches[0].pageX;
		a.y1 = k.touches[0].pageY;
		a.isMove = false;
		a.start = true;
		a.x2 = a.y2 = null;
	}, true);
	c(b, "touchmove", function (k) {
		a.isMove = true;
		a.x2 = k.touches[0].pageX;
		a.y2 = k.touches[0].pageY;
	}, true);
	c(b, "touchend", function (l) {
		d = d || "touchend";
		var k = false;
		a.isMove && a.x2 && Math.abs(a.x1 - a.x2) < 5 && a.y2 && Math.abs(a.y1 - a.y2) < 5 && (k = true);
		if (a.start && (!a.isMove || k)) {
			if (d != "touchend") {
				return;
			}
			e = setTimeout(function () {
				var m = h("tap");
				m.cancelTouch = f;
				g(a.el, m);
			}, 0);
		}
	}, true);
	c(b, "touchcancel", f, true);
	c(window, "scroll", f, true);
	c(b, "tap", function (l) {
		var k = j(l.target);
		if (k) {
			var m = k.scope.getAttribute("tapEventTimer");
			if (m) {
				return;
			}
			m = setTimeout(function () {
				k.scope.setAttribute("tapEventTimer", "");
			}, 500);
			k.scope.setAttribute("tapEventTimer", m);
			var n = k.onTap.call(k.scope, l);
			n === false && l.preventDefault();
		}
	}, false);
	c(b, "click", function (k) {
		d = d || "click";
		if (d != "click") {
			return;
		}
		var l = h("tap", k);
		l.cancelTouch = f;
		g(k.target, l);
	}, false);
});
define("TimeStat", function () {
	var a = 10, c = {
		index : {
			flag : "7721-145-1".split("-"),
			rate : a,
			useOpenTime : false
		},
		detail : {
			flag : "7721-145-2".split("-"),
			rate : 1,
			useOpenTime : true
		},
		myapp : {
			flag : "7721-145-3".split("-"),
			rate : a,
			useOpenTime : true
		},
		category : {
			flag : "7721-145-4".split("-"),
			rate : 1,
			useOpenTime : true
		},
		info : {
			flag : "7721-145-5".split("-"),
			rate : 1,
			useOpenTime : true
		},
		"index-render" : {
			flag : "7721-145-6".split("-"),
			rate : a,
			useOpenTime : false
		},
		"detail-render" : {
			flag : "7721-145-7".split("-"),
			rate : 1,
			useOpenTime : true
		},
		"myapp-render" : {
			flag : "7721-145-8".split("-"),
			rate : a,
			useOpenTime : true
		},
		"category-render" : {
			flag : "7721-145-9".split("-"),
			rate : 1,
			useOpenTime : true
		},
		"info-render" : {
			flag : "7721-145-10".split("-"),
			rate : 1,
			useOpenTime : true
		},
		search : {
			flag : "7721-145-11".split("-"),
			rate : a,
			useOpenTime : false
		}
	}, b = {
		pingURL : "http://isdspeed.qq.com/cgi-bin/r.cgi",
		isReported : false,
		report : function (g, d, i) {
			try {
				if ("search" != g && b.isReported) {
					return;
				}
				if (!i) {
					return setTimeout(function () {
						b.report(g, d, true);
					}, 3e3);
				}
				b.isReported = true;
				d = d || window.timestamps || [];
				"search" != g && (g += require("R").isRender ? "-render" : "");
				var f = c[g];
				if (!f) {
					return;
				}
				if (Math.random() > 1 / f.rate) {
					return;
				}
				var h = require("Api");
				require("Task").create(f.useOpenTime ? h.getUrlParam("openTime") : false).then(function (m) {
					if (f.useOpenTime) {
						var k = parseInt(m);
						h.setUrlParam("openTime", "");
						if (!k) {
							return;
						}
						d.unshift(new Date(k));
						if (d[1] - d[0] > 500) {
							return;
						}
					}
					if (d.length < 2) {
						return;
					}
					var l = ["flag1=" + f.flag[0], "flag2=" + f.flag[1], "flag3=" + f.flag[2], "flag5=" + f.rate], n = d[0];
					for (var e = 1; e < d.length; e++) {
						l.push(e + "=" + (d[e] - n));
					}
					require("pingSender").send(b.pingURL + "?" + l.join("&"));
					if ("search" != g && g.indexOf("detail") == -1) {
						var p = 71 + (require("LocalStorage").support ? 1 : 0) + (require("R").isRender ? 1 : 0);
						require("ValueStat").report("350594", 1, p, {
							reportRate : f.rate
						});
					}
				}).start();
			} catch (j) {
			}
		}
	};
	return b;
});
define("Task", function (e, f, c) {
	var b = function (g) {
		return Object.prototype.toString.call(g).slice(8, -1) == "Function";
	}, d = function (g) {
		window.setTimeout(g, 0);
	};
	function a(g) {
		this.msg = g;
		this.state = a.STATE.INIT;
		this.reason = null;
		this.async = false;
		this.parent = null;
		this.handles = [];
		this.children = [];
		this.context = {};
	}
	a.STATE = {
		INIT : 0,
		DELEGATING : 1,
		FULFILLED : 2,
		REJECTED : 3,
		FINISH : 4
	};
	a.isTask = function (g) {
		return g && b(g.then);
	};
	a.create = function (g) {
		return new a(g);
	};
	a.exec = function (g, h, k) {
		g.state = k;
		g.msg = h;
		if (a.STATE.FINISH == this.state) {
			return g;
		}
		if (a.isTask(h)) {
			a.reCall(g, h);
			return g;
		}
		var i = g.handles.shift();
		if (i) {
			var j = a.strategy[i.cmd];
			j && j.call(g, i);
		} else {
			!g.async && g.parent && g.parent.resolve(g.msg);
			!g.parent && a.destroy(g);
		}
		return g;
	};
	a.reCall = function (h, g) {
		a.isTask(g) ? (h.state = a.STATE.DELEGATING, g.parent = h, h.children.push(g), a.STATE.INIT == g.state ? g.start() : g.resolve(g.msg)) : h.resolve(g);
	};
	a.destroy = function (g) {
		g.children.forEach(function (h) {
			a.destroy(h);
		});
		g.destroy();
	};
	a.strategy = {
		then : function (j) {
			var i = a.STATE, k = j.fulfilled, h = j.rejected, g = "";
			try {
				i.FULFILLED == this.state && (g = k && k.call(this, this.msg));
				i.REJECTED == this.state && (g = h && h.call(this, this.msg));
			} catch (l) {
				this.state = i.REJECTED;
				this.reason = l.message;
				g = h && h.call(this, l);
			}
			this.msg = g;
			a.reCall(this, g);
		},
		map : function (m) {
			var n = this, g = m.map, i = {}, h = 0, j = function (k, q) {
				h--;
				i[k] = q;
				h == 0 && a.reCall(n, i);
			};
			b(g) && (g = g.call(this, this.msg));
			for (var l in g) {
				h++;
				var p = g[l];
				(function (q, k) {
					d(function () {
						b(k) || a.isTask(k) ? a.create(k).then(function (r) {
							j(q, r);
						}).start() : j(q, k);
					});
				})(l, p);
			}
		}
	};
	a.prototype.then = function (g, h) {
		this.handles.push({
			cmd : "then",
			fulfilled : g,
			rejected : h
		});
		return this;
	};
	a.prototype.map = function (g) {
		this.handles.push({
			cmd : "map",
			map : g
		});
		return this;
	};
	a.prototype.resolve = function (g) {
		if (a.STATE.FINISH == this.state) {
			return this;
		}
		return a.exec(this, g, a.STATE.FULFILLED);
	};
	a.prototype.reject = function (g) {
		return a.exec(this, g, a.STATE.REJECTED);
	};
	a.prototype.parentResolve = function (g) {
		this.parent && this.parent.resolve(g);
		return this;
	};
	a.prototype.parentReject = function (g) {
		this.parent && this.parent.reject(g);
		return this;
	};
	a.prototype.start = function () {
		while (b(this.msg)) {
			this.msg = this.msg.call(this);
		}
		return this.resolve(this.msg);
	};
	a.prototype.destroy = function () {
		this.state = a.STATE.FINISH;
		this.reason = null;
		this.parent = null;
		this.handles = [];
		this.context = {};
	};
	c.exports = a;
});
define("DefaultData", {
	app : {
		100422914 : {
			apkId : 0,
			appFeature : 0,
			appType : 4,
			appType_sub : 5011,
			appid_haina : 1264115,
			id : 100422914,
			isGenIcon : 0,
			isHot : 0,
			ismultipf : 0,
			mGame : 0,
			mark : 7,
			mark_nums : 339,
			mark_nums_all : 715,
			migid : 0,
			name : "水印相机",
			orientation : 0,
			pName : "com.tencent.zebra",
			playCount : 0,
			prelen : 3,
			quickbar : 0,
			secCate : "拍照",
			shortDes : "水印相机是国内首款智能水印应用",
			size : "22.0M",
			sourcetype : 0,
			status : 2,
			supportversion : "2.2+",
			tyqtype : 5,
			url : "http://down.myapp.com/android_new/186/836186/16496359/com.tencent.zebra_17.apk",
			userCount : 5884169,
			versionCode : 17,
			versionName : "1.3.1.232"
		},
		100621162 : {
			apkId : 0,
			appFeature : 0,
			appType : 4,
			appType_sub : 9004,
			appid_haina : 176236,
			id : 100621162,
			isGenIcon : 0,
			isHot : 0,
			ismultipf : 0,
			mGame : 0,
			mark : 8,
			mark_nums : 712,
			mark_nums_all : 1533,
			migid : 0,
			name : "我爱测",
			orientation : 0,
			pName : "com.memoriki.iquizmobilecn",
			playCount : 0,
			prelen : 3,
			quickbar : 0,
			secCate : "娱乐",
			shortDes : "",
			size : "2.3M",
			sourcetype : 0,
			status : 2,
			supportversion : "2.2+",
			tyqtype : 5,
			url : "http://down.myapp.com/android_new/711/595711/1178784/C06A343EEB459AB7B17496540EACD778.apk",
			userCount : 20916,
			versionCode : 19,
			versionName : "2.3.7"
		},
		100631344 : {
			apkId : 0,
			appFeature : 100631344,
			appType : 4,
			appType_sub : 5014,
			appid_haina : 0,
			id : 100631344,
			isGenIcon : 0,
			isHot : 0,
			ismultipf : 0,
			mGame : 0,
			mark : 7.752480030059814,
			mark_nums : 0,
			mark_nums_all : 0,
			migid : 100631344,
			name : "堆糖图片集",
			orientation : 0,
			pName : "com.duitang.huabao.qzone",
			playCount : 0,
			prelen : 1,
			quickbar : 0,
			secCate : "阅读",
			shortDes : "简约实用,全新移动浏览体验随时随地；发现和收集你喜爱的一切；在这里,重新发现生活；堆糖不止是一个网站；而是一种Lifestyle。",
			size : "1.6M",
			sourcetype : 0,
			status : 2,
			supportversion : "",
			tyqtype : 3,
			url : "http://softfile.3g.qq.com/msoft/sqapp/duitang_qzone0803.apk",
			userCount : 3236,
			versionCode : 30,
			versionName : "1.3"
		},
		100645222 : {
			apkId : 0,
			appFeature : 0,
			appType : 4,
			appType_sub : 5009,
			appid_haina : 1160099,
			id : 100645222,
			isGenIcon : 0,
			isHot : 0,
			ismultipf : 0,
			mGame : 0,
			mark : 6,
			mark_nums : 122,
			mark_nums_all : 289,
			migid : 0,
			name : "猜歌王",
			orientation : 0,
			pName : "air.GSMobile",
			playCount : 0,
			prelen : 3,
			quickbar : 0,
			secCate : "影音",
			shortDes : "热门音乐游戏，比比看谁知道的歌多",
			size : "10.1M",
			sourcetype : 0,
			status : 2,
			supportversion : "2.2+",
			tyqtype : 1,
			url : "http://www.myapp.com/downcenter/a/784732?g_f=990935",
			userCount : 19324933,
			versionCode : 1004e3,
			versionName : "1.4.0"
		},
		100680010 : {
			apkId : 0,
			appFeature : 0,
			appType : 4,
			appType_sub : 4014,
			appid_haina : 1206644,
			id : 100680010,
			isGenIcon : 0,
			isHot : 0,
			ismultipf : 0,
			mGame : 0,
			mark : 6,
			mark_nums : 133,
			mark_nums_all : 345,
			migid : 0,
			name : "答题王",
			orientation : 0,
			pName : "com.zhtiantian.ChallengerTX",
			playCount : 0,
			prelen : 3,
			quickbar : 0,
			secCate : "教育",
			shortDes : "上知天文，下知地理，智慧挑战，答题为王",
			size : "11.0M",
			sourcetype : 0,
			status : 2,
			supportversion : "2.2+",
			tyqtype : 1,
			url : "http://www.myapp.com/downcenter/a/788298?g_f=990935",
			userCount : 20490287,
			versionCode : 109,
			versionName : "3.5.2.24"
		},
		100682088 : {
			apkId : 0,
			appFeature : 0,
			appType : 4,
			appType_sub : 4014,
			appid_haina : 1206646,
			id : 100682088,
			isGenIcon : 0,
			isHot : 0,
			ismultipf : 0,
			mGame : 0,
			mark : 5,
			mark_nums : 9,
			mark_nums_all : 45,
			migid : 0,
			name : "疯狂答题",
			orientation : 0,
			pName : "com.itboy.fkdt",
			playCount : 0,
			prelen : 3,
			quickbar : 0,
			secCate : "教育",
			shortDes : "最好玩的益智答题对战游戏",
			size : "6.5M",
			sourcetype : 0,
			status : 2,
			supportversion : "2.2+",
			tyqtype : 1,
			url : "http://www.myapp.com/downcenter/a/788301?g_f=990935",
			userCount : 7045404,
			versionCode : 7,
			versionName : "1.5"
		},
		100682801 : {
			apkId : 0,
			appFeature : 0,
			appType : 4,
			appType_sub : 9004,
			appid_haina : 1205115,
			id : 100682801,
			isGenIcon : 0,
			isHot : 0,
			ismultipf : 0,
			mGame : 0,
			mark : 6,
			mark_nums : 5,
			mark_nums_all : 12,
			migid : 0,
			name : "百思不得姐移动",
			orientation : 0,
			pName : "com.sprite.budejie.qzone",
			playCount : 0,
			prelen : 3,
			quickbar : 0,
			secCate : "娱乐",
			shortDes : "每日更新内涵小漫画，热门段子",
			size : "2M",
			sourcetype : 0,
			status : 2,
			supportversion : "Android 2.2及以上",
			tyqtype : 1,
			url : "http://www.myapp.com/downcenter/a/788133?g_f=990935",
			userCount : 6593374,
			versionCode : 1,
			versionName : "1.0"
		},
		100686842 : {
			apkId : 0,
			appFeature : 3,
			appType : 4,
			appType_sub : 9022,
			appid_haina : 0,
			id : 100686842,
			isGenIcon : 0,
			isHot : 0,
			ismultipf : 0,
			mGame : 0,
			mark : 10,
			mark_nums : 0,
			mark_nums_all : 0,
			migid : 3,
			name : "私密日志",
			orientation : 0,
			pName : "",
			playCount : 0,
			prelen : 0,
			quickbar : 0,
			secCate : "生活",
			shortDes : "这是你的私密空间，你可以记下自己心里的小秘密，只有自己可见。",
			size : "",
			sourcetype : 1,
			status : 2,
			supportversion : "",
			tyqtype : 4,
			url : "http://fwd.z.qq.com:8080/forward.jsp?bid=232&g_f=150004",
			userCount : 70146130,
			versionCode : 0,
			versionName : ""
		},
		100686843 : {
			apkId : 0,
			appFeature : 4,
			appType : 4,
			appType_sub : 5010,
			appid_haina : 0,
			id : 100686843,
			isGenIcon : 0,
			isHot : 0,
			ismultipf : 0,
			mGame : 0,
			mark : 10,
			mark_nums : 0,
			mark_nums_all : 0,
			migid : 4,
			name : "好友日志",
			orientation : 0,
			pName : "",
			playCount : 0,
			prelen : 0,
			quickbar : 0,
			secCate : "社交",
			shortDes : "你可以查看全部好友的日志",
			size : "",
			sourcetype : 1,
			status : 2,
			supportversion : "",
			tyqtype : 4,
			url : "http://blog60.z.qq.com/friend_article_list.jsp",
			userCount : 69069259,
			versionCode : 0,
			versionName : ""
		},
		100686850 : {
			apkId : 0,
			appFeature : 0,
			appType : 4,
			appType_sub : 5014,
			appid_haina : 112099,
			id : 100686850,
			isGenIcon : 0,
			isHot : 0,
			ismultipf : 0,
			mGame : 0,
			mark : 4,
			mark_nums : 52,
			mark_nums_all : 329,
			migid : 0,
			name : "博雅书苑",
			orientation : 0,
			pName : "com.unimob.uiface",
			playCount : 0,
			prelen : 3,
			quickbar : 0,
			secCate : "阅读",
			shortDes : "",
			size : "2.8M",
			sourcetype : 0,
			status : 2,
			supportversion : "2.2+",
			tyqtype : 5,
			url : "http://down.myapp.com/msoft/15776/50879/78897/SOFTWARE/fsbooks_v1.0.apk",
			userCount : 87150,
			versionCode : 1,
			versionName : "1.0"
		},
		100686851 : {
			apkId : 0,
			appFeature : 0,
			appType : 4,
			appType_sub : 4020,
			appid_haina : 0,
			id : 100686851,
			isGenIcon : 0,
			isHot : 0,
			ismultipf : 0,
			mGame : 0,
			mark : 8,
			mark_nums : 160525,
			mark_nums_all : 292625,
			migid : 0,
			name : "应用宝",
			orientation : 0,
			pName : "com.tencent.android.qqdownloader",
			playCount : 0,
			prelen : 3,
			quickbar : 0,
			secCate : "系统",
			shortDes : "",
			size : "2.2M",
			sourcetype : 0,
			status : 5,
			supportversion : "2.2+",
			tyqtype : 6,
			url : "http://down.myapp.com/android/50801/15706511/com.tencent.android.qqdownloader_360425.apk",
			userCount : 197247997,
			versionCode : 360425,
			versionName : "3.6.0.425"
		},
		100686853 : {
			apkId : 0,
			appFeature : 0,
			appType : 4,
			appType_sub : 5014,
			appid_haina : 10555,
			id : 100686853,
			isGenIcon : 0,
			isHot : 0,
			ismultipf : 0,
			mGame : 0,
			mark : 8,
			mark_nums : 28202,
			mark_nums_all : 53065,
			migid : 0,
			name : "QQ阅读",
			orientation : 0,
			pName : "com.qq.reader",
			playCount : 0,
			prelen : 3,
			quickbar : 0,
			secCate : "阅读",
			shortDes : "培养大家读书的爱好是我不变的追求！支持全文档格式，图书种类也多，阅读体验赞。",
			size : "6.4M",
			sourcetype : 0,
			status : 2,
			supportversion : "2.2+",
			tyqtype : 5,
			url : "http://down.myapp.com/android/46442/16697474/com.qq.reader_33.apk",
			userCount : 45240700,
			versionCode : 33,
			versionName : "4.1.0.440"
		},
		100686920 : {
			apkId : 0,
			appFeature : 0,
			appType : 4,
			appType_sub : 5013,
			appid_haina : 206354,
			id : 100686920,
			isGenIcon : 0,
			isHot : 0,
			ismultipf : 0,
			mGame : 0,
			mark : 7,
			mark_nums : 138,
			mark_nums_all : 319,
			migid : 0,
			name : "自选股(腾讯炒股票软件)",
			orientation : 0,
			pName : "com.tencent.portfolio",
			playCount : 0,
			prelen : 3,
			quickbar : 0,
			secCate : "理财",
			shortDes : "企鹅出品的一款非常简约、易用的Android手机炒股软件，理财，赚钱，不是梦。",
			size : "6.3M",
			sourcetype : 0,
			status : 2,
			supportversion : "2.2+",
			tyqtype : 5,
			url : "http://down.myapp.com/android_new/997/561997/16727909/com.tencent.portfolio_20.apk",
			userCount : 606911,
			versionCode : 20,
			versionName : "2.8.2"
		},
		100686922 : {
			apkId : 0,
			appFeature : 0,
			appType : 4,
			appType_sub : 9023,
			appid_haina : 5613,
			id : 100686922,
			isGenIcon : 0,
			isHot : 0,
			ismultipf : 0,
			mGame : 0,
			mark : 8,
			mark_nums : 1108,
			mark_nums_all : 2089,
			migid : 0,
			name : "腾讯新闻",
			orientation : 0,
			pName : "com.tencent.news",
			playCount : 0,
			prelen : 3,
			quickbar : 0,
			secCate : "",
			shortDes : "新闻类应用中的标杆！重大事件瞬间推送，支持媒体订阅，收藏和分享。",
			size : "4.5M",
			sourcetype : 0,
			status : 2,
			supportversion : "2.2+",
			tyqtype : 5,
			url : "http://down.myapp.com/android_new/312/595312/16722219/com.tencent.news_321.apk",
			userCount : 11994721,
			versionCode : 321,
			versionName : "3.2.1"
		},
		100686925 : {
			apkId : 0,
			appFeature : 4406,
			appType : 4,
			appType_sub : 4019,
			appid_haina : 0,
			id : 100686925,
			isGenIcon : 0,
			isHot : 0,
			ismultipf : 0,
			mGame : 0,
			mark : 7,
			migid : 4406,
			name : "微云",
			orientation : 0,
			pName : "com.qq.qcloud",
			playCount : 0,
			prelen : 3,
			quickbar : 0,
			secCate : "工具",
			shortDes : "微云是腾讯公司为用户精心打造的一项智能云服务, 您可以通过微云方便地在手机和电脑之间,同步文件、推送照片和传输数据。",
			size : "8.4M",
			sourcetype : 0,
			status : 5,
			supportversion : "",
			tyqtype : 4,
			url : "http://dldir1.qq.com/weiyun/weiyun_android_1.6.338.56.apk",
			userCount : 105808,
			versionCode : 302,
			versionName : "1.5.0"
		},
		100686929 : {
			apkId : 0,
			appFeature : 0,
			appType : 4,
			appType_sub : 4019,
			appid_haina : 226189,
			id : 100686929,
			isGenIcon : 0,
			isHot : 0,
			ismultipf : 0,
			mGame : 0,
			mark : 7,
			mark_nums : 711,
			mark_nums_all : 1487,
			migid : 0,
			name : "QQ提醒",
			orientation : 0,
			pName : "com.tencent.qqcalendar",
			playCount : 0,
			prelen : 3,
			quickbar : 0,
			secCate : "工具",
			shortDes : "叫您起床，提醒您QQ好友的生日，领取游戏大礼包等，有了TA，生活更舒心。",
			size : "5.6M",
			sourcetype : 0,
			status : 2,
			supportversion : "2.2+",
			tyqtype : 5,
			url : "http://down.myapp.com/android_new/872/575872/16680079/com.tencent.qqcalendar_13.apk",
			userCount : 2369755,
			versionCode : 13,
			versionName : "2.3.1"
		},
		100686931 : {
			apkId : 0,
			appFeature : 0,
			appType : 4,
			appType_sub : 5011,
			appid_haina : 184954,
			id : 100686931,
			isGenIcon : 0,
			isHot : 0,
			ismultipf : 0,
			mGame : 0,
			mark : 8,
			mark_nums : 3767,
			mark_nums_all : 6301,
			migid : 0,
			name : "魅拍",
			orientation : 0,
			pName : "com.tencent.qqcamera",
			playCount : 0,
			prelen : 3,
			quickbar : 0,
			secCate : "拍照",
			shortDes : "对那些成天45度角，卖萌耍宝的自拍妹子，我真想说：拍拍拍，拍你“魅”啊。",
			size : "16.3M",
			sourcetype : 0,
			status : 2,
			supportversion : "2.2+",
			tyqtype : 5,
			url : "http://down.myapp.com/android_new/534/130534/16792996/com.tencent.qqcamera_61.apk",
			userCount : 6913543,
			versionCode : 61,
			versionName : "3.1.5"
		},
		100686935 : {
			apkId : 0,
			appFeature : 4411,
			appType : 4,
			appType_sub : 9004,
			appid_haina : 0,
			id : 100686935,
			isGenIcon : 0,
			isHot : 0,
			ismultipf : 0,
			mGame : 0,
			mark : 7,
			migid : 4411,
			name : "爱讲冷笑话",
			orientation : 0,
			pName : "com.coldworks.coldjoke",
			playCount : 0,
			prelen : 3,
			quickbar : 0,
			secCate : "娱乐",
			shortDes : "我们爱讲冷笑话，每日一冷，快乐每一天。冷笑话聚集地，这里有最冷最新潮的笑话的，还有更多爆笑图片奇闻趣事。",
			size : "1.3M",
			sourcetype : 0,
			status : 5,
			supportversion : "",
			tyqtype : 4,
			url : "http://softfile.3g.qq.com/msoft/sqapp/coldjoke_yingyongbao_0104.apk",
			userCount : 259763,
			versionCode : 0,
			versionName : "1.2.2"
		},
		100686944 : {
			apkId : 0,
			appFeature : 0,
			appType : 4,
			appType_sub : 4018,
			appid_haina : 10237,
			id : 100686944,
			isGenIcon : 0,
			isHot : 0,
			ismultipf : 0,
			mGame : 0,
			mark : 8,
			mark_nums : 2935,
			mark_nums_all : 5367,
			migid : 0,
			name : "SOSO街景地图",
			orientation : 0,
			pName : "com.tencent.map",
			playCount : 0,
			prelen : 3,
			quickbar : 0,
			secCate : "导航",
			shortDes : "微流量地图随心看。现在还有快捷叫车，美食酒店等生活优惠，不仅只是地图哦！",
			size : "10.9M",
			sourcetype : 0,
			status : 2,
			supportversion : "2.2+",
			tyqtype : 5,
			url : "http://down.myapp.com/android/42277/16676906/com.tencent.map_203.apk",
			userCount : 4848270,
			versionCode : 203,
			versionName : "3.2"
		},
		801008384 : {
			apkId : 0,
			appFeature : 0,
			appType : 4,
			appType_sub : 9004,
			appid_haina : 5640,
			id : 801008384,
			isGenIcon : 0,
			isHot : 0,
			ismultipf : 0,
			mGame : 0,
			mark : 7,
			mark_nums : 74,
			mark_nums_all : 153,
			migid : 0,
			name : "冷笑话精选",
			orientation : 0,
			pName : "com.feibo.joke",
			playCount : 0,
			prelen : 3,
			quickbar : 0,
			secCate : "娱乐",
			shortDes : "这年头，提升一个人的魅力指数，幽默是很重要的，而这款用软件会帮助你变得更幽默。",
			size : "3.1M",
			sourcetype : 0,
			status : 2,
			supportversion : "2.2+",
			tyqtype : 5,
			url : "http://down.myapp.com/android_new/10/91010/16757380/com.feibo.joke_32.apk",
			userCount : 284162,
			versionCode : 32,
			versionName : "3.4"
		},
		801097412 : {
			apkId : 0,
			appFeature : 0,
			appType : 4,
			appType_sub : 4019,
			appid_haina : 11384,
			id : 801097412,
			isGenIcon : 0,
			isHot : 0,
			ismultipf : 0,
			mGame : 0,
			mark : 9,
			mark_nums : 236502,
			mark_nums_all : 333496,
			migid : 0,
			name : "QQ浏览器",
			orientation : 0,
			pName : "com.tencent.mtt",
			playCount : 0,
			prelen : 3,
			quickbar : 0,
			secCate : "工具",
			shortDes : "超快的浏览器!同时还拥有清新的界面，操作也很简单，还支持阅读器和视频播放。",
			size : "10.4M",
			sourcetype : 0,
			status : 2,
			supportversion : "2.2+",
			tyqtype : 5,
			url : "http://down.myapp.com/android/49367/16840718/com.tencent.mtt_450520.apk",
			userCount : 86747960,
			versionCode : 450520,
			versionName : "4.5.2.540"
		}
	},
	category : {
		home : [100682801, 100682088, 100645222, 100680010, 100621162, 801008384, 100422914, 100686843, 100686853, 100686925, 100686922, 100686842, 801097412, 100686935, 100631344, 100686931],
		hotnogame : [100682801, 100682088, 100680010, 100422914, 100621162, 801008384, 100686922, 100686842, 801097412, 100686843, 100686853, 100686925, 100686935, 100631344, 100686931, 100686929, 100686851, 100686944, 100686920, 100686850],
		guess : [100682801, 100682088, 100680010, 100686931, 100621162, 100686925]
	}
});
define("Const", function () {
	var b = require("LocalStorage"), a = window.agentData || {}, c = {
		appid : "100",
		Currentversion : a.currentVersion || b.get("currentVersion"),
		Platform : a.platform || b.get("platform"),
		Uin : a.uin,
		url_prex : "http://app.z.qq.com/",
		channelId : 1e3,
		app_custom : "",
		AgentVersion : a.agentVersion || b.get("agentVersion"),
		MobileInfo : require("$").parseJSON(a.mobileInfo || b.get("mobileInfo")),
		Display : a.display || b.get("display"),
		pageParams : a.pageParams,
		imgRoot : a.imgRoot || b.get("imgRoot"),
		debug : true
	};
	return c;
});
define("LocalAppFileds", {
	pName : 0,
	versionCode : 1,
	versionName : 2,
	name : 3
});
define("QzoneApp", {
	Api : {},
	Mod : {}
});
define("JsBridge", function () {
	var a = {
		callback : function () {
			require("Event").fire.apply(require("Event"), arguments);
		}
	};
	return a;
});
define("Config", {
	app : "qzone_app",
	db : "qzone_db",
	http : "qzone_http",
	image : "qzone_imageCache",
	worker : "q_worker",
	download : "q_download",
	client : "qqZoneAppList",
	qqApi : "QQApi"
});
define("Bridge", function () {
	var b = require("LocalStorage"), a = {
		compatible : parseInt(require("LocalStorage").get("bridge_compatible")) || 3,
		reduce : function () {
			this.compatible > 1 && this.compatible--;
			b.set("bridge_compatible", this.compatible);
			b.set("bridge_compatible_time", Date.now());
		},
		createIframe : function () {
			var c = document.createElement("iframe");
			c.style.cssText = "display:none;width:0px;height:0px;";
			document.body.appendChild(c);
			return c;
		},
		removeIframe : function (d) {
			var c = document.querySelector("iframe_jsBridge_" + d);
			c && (c.src = "about:blank", document.body.removeChild(c));
		},
		send : function (g, h, i, j) {
			var d = j || {}, c = "jsbridge://" + [encodeURIComponent(g), encodeURIComponent(h), d.guid || 0].join("/");
			i.forEach(function (e) {
				c += "/" + encodeURIComponent(String(e));
			});
			var f = function () {
				var e = a.createIframe();
				e.id = "iframe_jsBridge_" + d.guid;
				e.src = c;
			};
			try {
				switch (a.compatible) {
					case 3:
						console.log(c);
						break;
					case 2:
						alert(c);
						break;
					case 1:
						f();
						break;
					default:
						require("M").stringReport({
							errMsg : "JSBridge do not support this compatible mode : " + a.compatible,
							code : -460,
							duration : 0
						});
				}
			} catch (k) {
				this.compatible = 0;
				f();
			}
		}
	};
	a.compatible != 3 && parseInt(b.get("bridge_compatible_time")) - 6048e5 > 0 && (a.compatible = 3);
	return a;
});
define("Notify", function (a, e) {
	var f = 5e3, c = {}, d = [], b = [], g = function () {
		var h = a("Bridge"), i = d.splice(0);
		h.compatible > 1 ? (h.reduce(), i.forEach(function (k) {
			var j = k && k[3];
			j.guid && (b[j.guid] && clearTimeout(b[j.guid]), j.timeout && (b[j.guid] = setTimeout(g, f)), d.push(k), h.send.apply(h, k));
		})) : a("M").stringReport({
			errMsg : "JSBridge do not support iframe compatible mode : " + h.compatible,
			code : -460,
			duration : 0
		});
	};
	e.pull = function (j, i, h, k) {
		return a("Task").create(function () {
			var m = this, l = a("Type");
			o = k || {};
			!o.guid && (o.guid = function () {
				var n = a("AsyncInterface").add(i, function (q) {
					var p = a("Bridge");
					if (b[n]) {
						clearTimeout(b[n]);
						var r = 70 + p.compatible;
						a("ValueStat").report("350716", 1, r, {
							reportRate : p.compatible == 3 ? 10 : 1
						});
					}
					m.parentResolve(q.data);
					delete c[n];
					delete b[n];
					p.compatible == 0 && p.removeIframe(n);
				});
				return n;
			}());
			h && (l.isObject(h) && (h = a("$").stringify(h)), !l.isArray(h) && (h = [].concat(h)));
			c[o.guid] = Date.now();
			o.timeout && (b[o.guid] = setTimeout(g, f));
			d.push([j, i, h || [], o]);
			a("Bridge").send(j, i, h || [], o);
			this.async = true;
		});
	};
	e.getDuration = function (h) {
		return c[h] || 0;
	};
});
define("Api", function () {
	var a = require("Const"), b = require("Config").client, c = {
		get : function (d, e) {
			if (!a[d] || e) {
				return require("Task").create(require("Notify").pull(b, "get" + d)).then(function (f) {
					a[d] = f;
					d == "Uin" && require("LocalStorage").set("uin", f);
					return f;
				});
			} else {
				return a[d];
			}
		},
		getUrlParam : function (d, e, i) {
			var f = require("Util"), g = a.pageParams, h = f.getUrlParam(d, e, i || g);
			if (!h && !g) {
				return require("Task").create(require("Notify").pull(b, "getParams")).then(function (j) {
					a.pageParams = j;
					return f.getUrlParam(d, e, j);
				});
			}
			return h;
		},
		getMobileInfo : function (d) {
			return !d && a.MobileInfo ? a.MobileInfo : require("Task").create(this.get("MobileInfo")).then(function (e) {
				a.MobileInfo = require("$").parseJSON(e);
				return e;
			});
		},
		openLocalUrl : function (d) {
			d.url = "sd://" + d.url;
			c.openUrl(d);
		},
		openUrl : function (e) {
			var d = e;
			if ("" == d.url) {
				return;
			}
			d.current = d.current || 0;
			d.titleInfo = d.titleInfo ? [].concat(d.titleInfo) : [];
			require("Notify").pull(b, "goUrl", d).start();
		},
		showMsg : function (d) {
			require("Notify").pull(b, "showToast", [String(d)]).start();
		},
		setUrlParam : function (d, e) {
			d !== "" && require("Task").create(c.getUrlParam(d)).then(function (g) {
				e = encodeURIComponent(e);
				var f = a.pageParams;
				g ? f = f.replace(new RegExp("([?#&]" + d + "=)([^#&]*)", "i"), "$1" + e) : f += "&" + d + "=" + e;
				a.pageParams = f;
				require("Notify").pull(b, "setParams", [f]).start();
			}).start();
		},
		setAllowCallBackEvent : function (d) {
			require("Notify").pull(b, "setAllowCallBackEvent", [d ? 1 : 0]).start();
		},
		goToDetailPage : function (d) {
			var e = {
				url : d.url,
				appid : d.appid,
				apkId : d.apkId,
				myAppId : d.myAppId,
				packageName : d.pName,
				via : d.via,
				versionCode : d.versionCode,
				isAutoDownload : d.isAutoDownload,
				isAutoInstall : d.isAutoInstall
			};
			e = require("$").stringify(e);
			require("Notify").pull(b, "goToDetailPage", [e, "" + (d.toMyApp || 1)]).start();
		}
	};
	return c;
});
define("App", function () {
	var b = require("Config").app, a = {
		name : require("TableConfig").app.name,
		name_userInfo : require("TableConfig").user_info.name,
		idCache : {},
		pNameCache : {},
		dfData : require("DfData") || {},
		add : function (c) {
			var d = require("Util"), e = this, c = [].concat(c), f = [], h = [], g = [];
			d.each(c, function (i) {
				g.push(i.id);
			});
			require("Task").create().map({
				uin : require("Api").get("Uin"),
				localRet : a.getAppsByIds(g, true)
			}).then(function (k) {
				var j = require("$"), i = require("Database"), l = k.uin, m = k.localRet, n = !!m.length;
				n && (c.forEach(function (p) {
					var q = a.idCache[p.id];
					q ? (d.each(p, function (r, s) {
						r && (q[s] = r);
					}), f.push(q)) : f.push(p);
				}), c = f);
				i.multiUpdate({
					into : e.name_userInfo,
					fields : "id, info, friends, feeds, code",
					values : c
				}, function (q) {
					var p = [], r = {};
					r.playCount = q.playCount;
					p.push(q.id);
					p.push(i._escSql(j.stringify(r)));
					p.push(i._escSql(j.stringify(q.friends || {})));
					p.push(i._escSql(j.stringify(q.feeds || "")));
					p.push(l);
					return p;
				});
				return i.multiUpdate({
					into : e.name,
					fields : "id,v,imid,pName,ext",
					values : c
				}, function (r) {
					var q = [], p = {};
					p = d.extend(p, r);
					p.feeds && delete p.feeds;
					p.friends && delete p.friends;
					p.playCount && delete p.playCount;
					q.push(p.id);
					q.push(i._escSql(j.stringify(p)));
					q.push(p.migid || 0);
					q.push(p.pName || "");
					q.push(i._escSql(j.stringify({
						des : p.des || "",
						newFeature : p.newFeature || ""
					})));
					e._saveCache(r);
					return q;
				});
			}).start();
		},
		_saveCache : function (c) {
			this.idCache[c.id] = c;
			this.pNameCache[c.pName] = c;
		},
		__parseApp : function (d, k) {
			var e = require("$"), f = require("Util"), c = e.parseJSON(d[0]) || k, g = d[1] && e.parseJSON(d[1]) || null, h = d[2] && e.parseJSON(d[2]) || null, i = d[3] && e.parseJSON(d[3]) || null, j = d[4] && e.parseJSON(d[4]) || null;
			if (c.id) {
				g && (c = f.extend(c, g));
				h && (c = f.extend(c, h));
				i && (c = f.extend(c, {
					friends : i
				}));
				j && (c = f.extend(c, {
					feeds : j
				}));
				return c;
			}
			return null;
		},
		getAppById : function (c, d) {
			return require("Task").create(this.getAppsByIds(c, d)).then(function (e) {
				return e && e[0] || null;
			});
		},
		getAppByPName : function (c, e) {
			if (this.pNameCache[c]) {
				return this.pNameCache[c];
			}
			var d = 0;
			return require("Task").create(require("Api").get("Uin")).then(function (f) {
				d = f;
			}).then(require("Database").select({
				select : "a.v, a.ext, u.info, u.friends, u.feeds",
				from : a.name + " a , " + a.name_userInfo + " u",
				where : 'a.pName = "' + c + '" and u.id = a.id and u.code = ' + d
			})).then(function (f) {
				var h = e ? null : a.dfData.pName && a.dfData.pName[c];
				f = require("$").parseJSON(f);
				if (f.length) {
					var g = a.__parseApp(f[0], h);
					g && a._saveCache(g);
				}
				return g || h || null;
			});
		},
		getAppsByIds : function (c, l) {
			var d = require("Util"), e = this, f = [], g = [], h = e.idCache, i = 0;
			c = [].concat(c);
			var j = a.dfData.app || {}, k = function () {
				d.each(c, function (m) {
					h[m] ? g.push(h[m]) : !l && j[m] && g.push(j[m]);
				});
				return g;
			};
			d.each(c, function (m) {
				!h[m] && f.push(m);
			});
			if (f.length > 0) {
				return require("Task").create(require("Api").get("Uin")).then(function (m) {
					i = m;
					return require("Database").select({
						select : "a.v, a.ext, u.info, u.friends, u.feeds",
						from : a.name + " a , " + a.name_userInfo + " u",
						where : "a.id in (" + f.join(",") + ") and u.id = a.id and  u.code = " + i
					});
				}).then(function (m) {
					m = require("$").parseJSON(m);
					d.each(m, function (p) {
						try {
							var n = e.__parseApp(p);
							n && e._saveCache(n);
						} catch (q) {
						}
					});
					return k();
				});
			}
			return k();
		},
		getAppsByCate : function (c, d, e, f) {
			return require("Task").create(require("Category").getCategory(c, d, e)).then(function (g) {
				return g.length > 0 ? a.getAppsByIds(g, f) : [];
			}).then(function (g) {
				return g;
			});
		},
		getInstalledApp : function () {
			return require("Task").create(require("Notify").pull(b, "getAllDownAppInfo", [false, false, false])).then(function (c) {
				return c ? require("$").parseJSON(c) : [];
			});
		},
		getAppInfo : function (c) {
			if (require("Type").isArray(c)) {
				return require("Task").create(require("Notify").pull(b, "getAppInfoBatch", [c.join(","), ",", false, false, false])).then(function (d) {
					return d && require("$").parseJSON(d) || [];
				});
			} else {
				return require("Task").create(require("Notify").pull(b, "getAppInfo", [c, false, false, false])).then(function (d) {
					return d && require("$").parseJSON(d) || [];
				});
			}
		},
		isInstall : function (c) {
			if (require("Type").isArray(c)) {
				return require("Task").create(require("Notify").pull(require("Config").client, "appIsExistsBatch", [c.join(","), ","])).then(function (d) {
					return String(d) || "";
				});
			} else {
				return require("Task").create(require("Notify").pull(require("Config").client, "appIsExists", [c])).then(function (d) {
					return String(d) == "true" ? true : false;
				});
			}
		},
		unInstallApp : function (d, c) {
			c && (require("Storage").setMemValue(c, d + ""), require("Notify").pull(b, "uninstallApp", [c]).start());
		},
		startApp : function (n) {
			var c = n || {};
			c.tyqtype += "";
			c.appid += "";
			var f = require("Channel"), k = require("Via"), h = require("Const"), i, g, l, j, e = c.channelId, d = function () {
				require("Update").userAddApp(c.appid);
				require("Category").changeRecentPlay(c.appid);
			}, m = function () {
				var p = require("Notify"), q = require("Config").client;
				switch (c.tyqtype) {
					case "0":
						p.pull(q, "startApp", [c.pName, c.appurl]).start();
						d();
						break;
					case "1":
						p.pull(q, "startOpenApp", [c.pName, c.appurl, c.appid, "", c.appCustom || h.app_custom]).start();
						d();
						break;
					case "2":
						p.pull(q, "startAppWithData", [c.pName, c.appurl]).start();
						d();
						break;
					case "3":
						p.pull(q, "startOpenApp", [c.pName, c.appurl, c.appid, "", c.appCustom || h.app_custom]).start();
						d();
						break;
					case "4":
						p.pull(q, "startApp", [c.pName, c.appurl]).start();
						d();
						break;
					case "5":
						p.pull(q, "startOpenApp", [c.pName, c.appurl, c.appid, "", c.appCustom || h.app_custom]).start();
						d();
						break;
					case "6":
						p.pull(q, "startApp", [c.pName, c.appurl]).start();
						d();
						break;
					default:
						p.pull(q, "startApp", [c.pName, c.appurl]).start();
						break;
				}
			};
			require("Task").create().map({
				app : a.getAppById(c.appid),
				via : k.getPageVia(e == f.HOMESOCIAL || e == f.HOMEREC || e == f.SEARCHRESULT ? e : ""),
				channelVia : k.getChannelVia(e)
			}).then(function (p) {
				i = p.app, g = p.via, l = p.channelVia;
				g = e == f.HOMESOCIAL ? g + "." + c.rank : g;
				j = f.DETAIL == require("Const").channelId ? l : g;
				c.pName && (i.ieg_ticket ? (require("Notify").pull(require("Config").qqApi, "launchAppWithTokens", [c.appid, i.ieg_ticket, c.pName, "0"]).then(function () {
				}, function (q) {
					q.r == 1 && m();
				}).start(), d()) : m());
				!c.isAutoStart ? require("Stat").startApp(j, c.appid) : require("Stat").autoStartApp(j, c.appid);
			}).start();
		},
		goWebApp : function (i) {
			var c = i || {};
			c.tyqtype += "";
			var f = require("Channel"), h = require("Via"), j, k, l, g, e = c.channelId, d = c.appid += "";
			c.appurl ? require("Task").create().map({
				app : a.getAppById(d),
				via : h.getPageVia(e == f.HOMESOCIAL || e == f.HOMEREC || e == f.SEARCHRESULT ? e : ""),
				channelVia : h.getChannelVia(e)
			}).then(function (q) {
				var m = q.app, n = q.via, s = q.channelVia, p = m.sourcetype == 2, r = p ? 1 == m.quickbar ? 1 : 0 : 1;
				n = e == f.HOMESOCIAL ? n + "." + c.rank : n;
				g = f.DETAIL == require("Const").channelId ? s : n;
				!c.isAutoStart ? require("Stat").startApp(g, d) : require("Stat").autoStartApp(g, d);
				require("Update").userAddApp(d);
				require("Category").changeRecentPlay(d);
				require("Notify").pull(require("Config").client, "goWebApp", {
					appid : d,
					webviewConfig : p ? m.webviewConfig || 255 : -1,
					args : c.webargs || "",
					strUrl : c.appurl,
					type : p ? 1 : 0,
					showQuickBar : r,
					screenOrientation : m.orientation || 0,
					fullScreen : r ? 0 : 1,
					showDialog : p ? 1 == m.isGenIcon ? 1 : 0 : 0,
					appName : m.name,
					appIconUrl : require("ImgCache").getImgUrl("logo", d, d + "_100_m.png")
				}).start();
			}).start() : require("Api").showMsg("应用地址为空，启动应用失败");
		},
		getRecentApp : function () {
			var c = require("LocalStorage").get("latest_num") || 5;
			return require("Notify").pull(b, "getRecentApp", [c]);
		},
		getAppVersionCode : function (c, d, e) {
			return require("Task").create(require("Notify").pull(require("Config").client, "getAppVersionCode", {
				packageName : d,
				appid : c,
				downloadUrl : e
			})).then(function (f) {
				f && (f = require("$").parseJSON(f.replace(/\s+/g, "")));
				return f;
			});
		}
	};
	return a;
});
define("AppUpdateData", function () {
	var a = {
		data : {},
		map : {},
		check : function (b) {
			b = [].concat(b);
			b.length && require("Task").create(require("Notify").pull(require("Config").download, "checkUpdate", {
				packageNames : b
			})).then(function (c) {
				c = require("$").parseJSON(c);
				a.data = c;
				require("Util").each(c, function (d) {
					d.packageName && (a.map[d.packageName] = d);
				});
			}).start();
		},
		getByPName : function (b) {
			return a.map[b] || "";
		}
	};
	return a;
});
define("AsyncInterface", function () {
	var d = require("Events").eventEmitter, a = new d(), b = 0, c = location.pathname.slice(location.pathname.lastIndexOf("/") + 1) + "_", e = {
		evt : a,
		add : function (f, g) {
			++b;
			a.on(c + f + "_" + b, g);
			return b;
		},
		emit : function (f, g, h) {
			a.emit.call(a, c + f + "_" + g, h);
		},
		up : function () {
			return ++b;
		}
	};
	return e;
});
define("Collector", function () {
	var b = require("Events").eventEmitter, a = function (c, d) {
		this.time = c || 1e3;
		this.count = d || 10;
		this.timer = null;
		this.pool = [];
		this.evt = new b();
	};
	a.prototype = {
		push : function (c) {
			var d = this;
			this.pool.push(c);
			!this.timer && (this.timer = setTimeout(function () {
				d.fulled();
			}, this.time));
			this.pool.length > this.count && this.fulled();
		},
		fulled : function () {
			this.timer && (this.timer = clearTimeout(this.timer));
			this.evt.emit("fulled", this.pool.splice(0));
		},
		on : function () {
			this.evt.on.apply(this.evt, arguments);
		}
	};
	return a;
});
define("Category", function () {
	var a = {
		name : require("TableConfig").category.name,
		id : {
			home : "home_",
			hotnogame : "hotnogame_",
			latest_used_app : "latest_used_app",
			myapplist_v2 : "myapplist_v2_",
			myapp_pc : "myapp_pc_",
			updateapp : "updateapp_",
			notify : "notify_",
			def_home : "def_home",
			def_hotnogame : "def_hotnogame",
			def_guess : "def_guess"
		},
		cate : {},
		cateNext : null,
		getCategory : function (c, f, d) {
			var b;
			d = d || require("Update").pageSize;
			var e = function () {
				b = [].concat(b);
				if (f) {
					var h = Math.max(0, f - 1) * d, i = Math.min(b.length, h + d);
					return b.slice(h, i);
				} else {
					return b;
				}
			};
			if (/^def_/.test(c)) {
				var g = require("DfData").category || {};
				b = g[c.replace(/^def_/, "")];
				return e();
			} else {
				return require("Task").create(require("Api").get("Uin")).then(function (i) {
					var j = this;
					c += i;
					b = a.cate[c];
					if (!b) {
						var h = require("LocalStorage");
						if (h.support) {
							b = require("$").parseJSON(h.get(c)) || [];
							return e();
						} else {
							return require("Task").create(require("Database").select({
								select : "v",
								from : a.name,
								where : {
									id : c
								}
							})).then(function (k) {
								var l = require("$");
								k = l.parseJSON(k);
								b = k && k.length > 0 ? l.parseJSON(k[0][0]) : [];
								a.cate[c] = b;
								return e();
							});
						}
					} else {
						return e();
					}
				});
			}
		},
		getCateNext : function (b, c) {
			c += "";
			if (!this.cateNext) {
				return require("Task").create().map({
					uin : require("Api").get("Uin"),
					cateNext : require("Storage").getItem("cateNext")
				}).then(function (d) {
					b += d.uin;
					a.cateNext = require("$").parseJSON(d.cateNext) || {};
					!a.cateNext[b] && (a.cateNext[b] = {});
					return a.cateNext[b][c] || false;
				});
			} else {
				return require("Task").create(require("Api").get("Uin")).then(function (d) {
					b += d;
					!a.cateNext[b] && (a.cateNext[b] = {});
					return a.cateNext[b][c] || false;
				});
			}
		},
		setCateNext : function (b, c, d) {
			c += "";
			require("Task").create(require("Api").get("Uin")).then(function (e) {
				b += e;
				!a.cateNext[b] && (a.cateNext[b] = {});
				a.cateNext[b][c] = d;
				require("Storage").setItem("cateNext", require("$").stringify(a.cateNext));
			}).start();
		},
		addIntoCategory : function (b, c, d) {
			require("Task").create(this.getCategory(b)).then(function (e) {
				e && (e = require("Util").addToArray(e, c, d), a.setCategory(b, e));
			}).start();
		},
		removeFromCategory : function (b, c) {
			require("Task").create(this.getCategory(b)).then(function (d) {
				d.length && (d = require("Util").removeFromArray(d, c), a.setCategory(b, d));
			}).start();
		},
		setCategory : function (b, c) {
			c && require("Task").create(require("Api").get("Uin")).then(function (e) {
				b += e;
				a.cate[b] = c;
				var d = require("LocalStorage");
				d.support ? d.set(b, require("$").stringify(c)) : require("Database").update({
					into : a.name,
					values : {
						id : b,
						v : require("$").stringify(c)
					}
				});
			}).start();
		},
		changeRecentPlay : function (b) {
			require("Task").create().map({
				cate : this.getCategory(this.id.latest_used_app),
				pcapps : this.getCategory(this.id.myapp_pc)
			}).then(function (d) {
				b = parseInt(b);
				var c = d.cate, e = d.pcapps;
				c = require("Util").removeFromArray(c, b);
				c.splice(e.length, 0, b);
				a.setCategory(a.id.latest_used_app, c);
			}).start();
		}
	};
	return a;
});
define("Database", function () {
	var a = require("Config").db, b = {
		tables : {},
		tmpl : {
			create : "create table <%=tName%> <%=fields%>;",
			drop : "drop table if exists <%=tName%>;",
			select : ["select <%=data.select%> ", "from <%=data.from%> ", "<% var where = data.where, t =[]; if(where) { %>", "where ", '<% if(typeof where == "string") { %>', "<%=where%>", "<% } else { %>", "<% for(var k in where) {%>", "<% one = where[k];%>", "<% if(one){ %>", "<% if(one.op){ %>", '<% t.push(k + " " + one.op + " "  + "\'" + rep(one.value) + "\'");%>', "<% } else { %>", '<% t.push(k + "=" + "\'" + rep(one) + "\'");%>', "<% } %>", "<% } %>", "<% }%>", '<%=t.join(" and ")%>', "<% } %>", "<% } %>", ";"].join(""),
			del : ["delete from <%=data.from%> ", "<% if(data.where) { var t =[];%>", '<% if(typeof where == "string") { %>', "<%=where%>", "<% } else { %>", "where ", '<% for(var k in data.where) { t.push( k + "=" + "\'" + rep(data.where[k]) + "\'"); } %>', '<%=t.join(" and ")%>', "<% } %>", "<% } %>", ";"].join(""),
			update : ["replace into <%=data.into%>", '<% var k =[],v=[]; for(var _k in data.values) { k.push( _k); v.push("\'" + rep(data.values[_k]) + "\'")} %>', '(<%=k.join(",")%>)', 'values(<%=v.join(",")%>);'].join(""),
			mutliUpdate : ["replace into <%=data.into%>", "(<%=data.fields%>) ", '<% var t=[]; for(var k in data.values) { if(!data.values[k]) {continue;} var d = callBack(data.values[k]); for(var i = 0; i < d.length; i++) { d[i] = "\'" + rep(d[i])+"\'"; } t.push("select " + d.join(","))} %>', '<%=t.join(" union all ")%>'].join("")
		},
		verifyTable : function () {
			require("Notify").pull(a, "verifyTable", require("TableConfig"), {
				timeout : true
			}).start();
		},
		select : function (c) {
			var d = require("Str").tmpl(this.tmpl.select, {
				data : c,
				rep : this._escSql
			});
			return require("Notify").pull(a, "select", [d]);
		},
		del : function (c) {
			var d = require("Str").tmpl(this.tmpl.del, {
				data : c,
				rep : this._escSql
			});
			require("Notify").pull(a, "exec", [d]).start();
		},
		update : function (c) {
			var d = require("Str").tmpl(this.tmpl.update, {
				data : c,
				rep : this._escSql
			});
			require("Notify").pull(a, "exec", [d]).start();
		},
		multiUpdate : function (c, d) {
			var e = require("Str").tmpl(this.tmpl.mutliUpdate, {
				data : c,
				callBack : d,
				rep : this._escSql
			});
			require("Notify").pull(a, "exec", [e]).start();
		},
		_escSql : function (c) {
			c = c + "";
			return c.replace(/'/g, "''");
		}
	};
	b.verifyTable();
	return b;
});
define("DfData", function () {
	var b = require("Util"), a = require("DefaultData");
	a && a.app && (a.pName = {}, b.each(a.category, function (d, c) {
		a[c] = [];
		b.each(d, function (f) {
			var e = a.app[f];
			e && (a[c].push(e), e.pName && (a.pName[e.pName] = e));
		});
	}));
	return a;
});
define("Download", function () {
	var b = require("Config").download, d = require("Events").eventEmitter, c = 1101070898, a = {
		STATE : {
			ALL : 0,
			INIT : 1,
			DOWN : 2,
			PAUSE : 3,
			DOWN_END : 4,
			SETUP : 5,
			SETUP_END : 6,
			SETUP_END_UPDATEPROSTATE : 100,
			UNINSTALL_END : 9,
			CANCEL : 10,
			UPDATE : 12,
			PACKAGE_REPLACE : 13,
			WAIT : 20,
			ERROR_SYSTEM : -1,
			ERROR_DOWN_EXCEPTION : -2,
			ERROR_SD_UNMOUNT : -3,
			ERROR_URL_CHANGE : -4,
			ERROR_NET_ERROR : -5,
			ERROR_SD_NOSPACE : -6
		},
		PSTATE : {
			DEFAULT : 0,
			INSTALL : 1,
			UNINSTALL : 2
		},
		evt : new d(),
		downData : {},
		_proCache : {},
		init : function () {
			require("Event").on("loadProcess", function () {
				a.nativeCallback.apply(a, arguments);
			});
			this.addListener(this.STATE.UNINSTALL_END, function (e) {
				e.appid && a.updateProState(e.appid, a.PSTATE.UNINSTALL);
			});
			this.addListener(this.STATE.SETUP_END_UPDATEPROSTATE, function (f) {
				var e = f.appid;
				e && (a.updateProState(e, a.PSTATE.INSTALL), require("Task").create(require("App").getAppById(e)).then(function (g) {
					g && /^[23456]$/.test(g.tyqtype) && (require("Update").userAddApp(e, undefined, "install"), require("Category").changeRecentPlay(e));
				}).start());
			});
		},
		addListener : function (e, f) {
			this.evt.on(e, f);
		},
		notify : function (f, g, h) {
			var e = h || {};
			this.evt.emit(f, e.overwrite || this.downData[g], e.isQuery);
		},
		nativeCallback : function (f) {
			var g = this;
			try {
				if (require("Type").isArray(f)) {
					require("Util").each(f, function (e) {
						g.nativeCallback(e);
					});
				} else {
					var i = f.appid, h = f.packagename;
					h && !i ? require("Task").create(require("Storage").getMemValue(h)).then(function (e) {
						var k = function () {
							e && f.state && g.downCallback({
								appid : e,
								pro : 0,
								state : f.state,
								phony_pro : 0
							});
						};
						!e ? require("Task").create(require("App").getAppByPName(h)).then(function (l) {
							l && (e = l.id) && k();
						}).start() : k();
					}).start() : g.downCallback(f);
				}
			} catch (j) {
			}
		},
		downCallback : function (e, f) {
			this.downData[e.appid] = e;
			this.notify(e.state, e.appid, {
				isQuery : f
			});
			this.notify(this.STATE.ALL, e.appid, {
				isQuery : f
			});
			this.STATE.SETUP_END == e.state && this.notify(this.STATE.SETUP_END_UPDATEPROSTATE, e.appid, {
				isQuery : f
			});
		},
		getProState : function (e) {
			return this._proCache[e] || 0;
		},
		updateProState : function (e, f, g) {
			var h = this._proCache[e] || 0;
			this.PSTATE.UNINSTALL == f && !g && require("Task").create(this.query(e, {
				needRet : true
			})).then(function (i) {
				i && !i[0] && h == 1 && (e == c ? a.downCallback({
					appid : c,
					pro : 100,
					state : a.STATE.DOWN_END,
					phony_pro : 100
				}, true) : a.notify(a.STATE.UNINSTALL_END, e, {
					overwrite : {
						appid : e,
						pro : 0,
						state : a.STATE.UNINSTALL_END,
						phony_pro : 0
					}
				}));
			}).start();
			this._proCache[e] = f;
		},
		query : function (e, i) {
			var g = this, f = i || {}, e = [].concat(e), h = require("Task").create(require("App").getAppsByIds(e)).then(function (k) {
				var j = [];
				require("Util").each(k, function (l) {
					j.push({
						appid : l.id,
						myAppId : l.appid_haina || l.myAppId || "",
						apkId : l.apkId || "",
						packageName : l.pName,
						versionCode : l.versionCode
					});
				});
				return require("Notify").pull(b, "getQueryDownloadAction", [require("$").stringify(j)]);
			}).then(function (j) {
				require("Util").each(j, function (l) {
					g.downCallback(l, true);
					l.appid == c && (f.yyb = false);
				});
				1 == a.getProState(c) && (f.yyb = false);
				if (f.yyb) {
					var k = {
						appid : c,
						pro : 100,
						state : a.STATE.DOWN_END,
						phony_pro : 100
					};
					j.push(k);
					g.downCallback(k, true);
				}
				return j;
			});
			return f.needRet ? h : h.start();
		},
		getSourceVia : function (e) {
			return "";
		},
		cancelNotification : function (e, f) {
			e && require("Notify").pull(b, "cancelNotification", ["_" + e]).start();
			f && require("Notify").pull(b, "cancelNotification", ["" + f]).start();
		},
		cancel : function (e) {
			require("Notify").pull(b, "cancelDownload", ["" + e, "_" + e]).start();
		},
		go : function (x) {
			var p = require("Const"), k = require("App"), l = require("Via"), i = require("Channel"), f = this.STATE, q = null, r = null, j = null, s = null, t = null, u = null, e = x || {}, h = e.channelId, v = e.overWriteState || "", y = e.pcpush ? "1" : "0", g = this.downData[e.appid] || "", m = "", n = function (z) {
				z != f.SETUP && (g.state = z);
				var A = {
					myAppConfig : e.pName == "com.tencent.android.qqdownloader" && e.isUpdate ? 0 : e.myAppConfig,
					appid : e.appid + "",
					url : e.appurl,
					packageName : e.pName,
					actionCode : z,
					via : u ? msgVia : t ? r : q,
					appName : j.name,
					notifyKey : "N_" + e.appid,
					updateData : require("AppUpdateData").getByPName(e.pName) || "",
					updateType : 0,
					myAppId : parseInt(e.myAppId, 10) == 0 ? "" : e.myAppId,
					apkId : parseInt(e.apkId, 10) == 0 ? "" : e.apkId,
					versionCode : e.versionCode,
					isAutoDownload : "1",
					isAutoInstall : "1",
					toPageType : e.toPageType,
					showNetworkDialog : y
				};
				require("Notify").pull(b, "doDownloadAction", A).start();
			}, w = function () {
				!g && (g = {
					appid : e.appid,
					pro : 0,
					state : f.INIT,
					phony_pro : 0
				}, a.downData[e.appid] = g);
				g.state = Math.max(1, g.state);
				v && (g.state = v);
				switch (g.state) {
					case f.INIT:
						m = e.isUpdate ? f.UPDATE : f.DOWN;
						a.notify(f.INIT, e.appid);
					case f.PAUSE:
					case f.UPDATE:
					case f.UNINSTALL_END:
					case f.WAIT:
					case f.CANCEL:
						n(m || f.DOWN);
						a.notify(m || f.DOWN, e.appid);
						break;
					case f.DOWN:
						n(f.PAUSE);
						a.notify(f.PAUSE, e.appid);
						break;
					case f.DOWN_END:
						n(f.SETUP);
						a.notify(f.SETUP, e.appid);
						break;
					case f.SETUP_END:
						a.notify(f.SETUP_END, e.appid);
						return true;
				}
				return false;
			};
			return require("Task").create().map({
				via : l.getPageVia(h == i.HOMESOCIAL || h == i.HOMEREC || h == i.SEARCHRESULT ? h : ""),
				channelVia : l.getChannelVia(h),
				msgVia : l.getMsgVia(h),
				appInfo : k.getAppById(Math.abs(e.appid)),
				isInstall : k.isInstall(e.pName)
			}).then(function (z) {
				q = z.via + (h == i.HOMESOCIAL ? "." + e.rank : "") + a.getSourceVia(e.appid), r = z.channelVia + a.getSourceVia(e.appid);
				msgVia = z.msgVia;
				j = z.appInfo;
				s = z.isInstall;
				t = i.DETAIL == p.channelId;
				u = i.ASSISTANT == p.channelId;
				if (!e.isUpdate && e.pName && s) {
					return "isInstall";
				}
				if (!j) {
					return true;
				}
				if (e.isUpdate) {
					return require("Task").create(k.getAppInfo(e.pName)).then(function (A) {
						if (A && require("Type").isArray(A)) {
							var B = require("LocalAppFileds");
							if (parseInt(j.versionCode) == parseInt(A && A[B.versionCode])) {
								return true;
							}
							return w();
						}
					});
				}
				return w();
			});
		}
	};
	a.init();
	return a;
});
define("Event", function () {
	var b = require("Events").eventEmitter, a = new b();
	a.fire = function () {
		var m = require("Util"), e = String(arguments[0]);
		if (e.indexOf(".") > -1) {
			e = e.split(".");
			var g = e[0], h = e[1], i = function (n, p, q, r) {
				require("M").stringReport({
					errMsg : n,
					code : p,
					duration : q,
					reportRate : r || 0
				});
			};
			switch (g) {
				case "interface":
					var k = require("Type"), l = require("$"), d = arguments[1];
					k.isString(d) && (d = l.parseJSON(d));
					if (d && d.guid) {
						var j = d.guid, f = require("Notify").getDuration(j);
						f = Date.now() - f;
						f > 500 && i("namespace [ " + g + " ] notify method [ " + h + " ] Native call Time-consuming!", -430, f, 1e4);
						d.ret == -1 && i("namespace [ " + g + " ] notify method [ " + h + " ] Native call cause Error!", d.ret, f);
					}
					require("AsyncInterface").emit(h, j, d);
					break;
			}
		} else {
			this.emit.apply(this, arguments);
		}
	};
	var c = require("QzoneApp");
	c.fire = function () {
		a.fire.apply(a, arguments);
	};
	return a;
});
define("Http", function () {
	var c = require("Config").http, a = {
		guid : 0,
		pool : {},
		_reqcallback : function (e, d) {
			var f = this.pool[e.guid] || {}, d = f[d];
			d && d.call(null, e.content ? require("$").parseJSON(e.content) : {}, e.guid);
		},
		onError : function (d) {
			d && this._reqcallback(d, "error");
			var e = require("Api");
			require("Task").create(e.get("APNType", true)).then(function (f) {
				e.showMsg(f > 0 ? "服务器请求失败，请重试" : "网络无连接");
			}).start();
		},
		onSuccess : function (d) {
			d && this._reqcallback(d, "success");
		},
		serializeParam : function (e) {
			var d = require("Api");
			return require("Task").create().map({
				keytype : "256",
				version : require("M").JSVersion || "0",
				platform : d.get("Platform"),
				keystr : d.get("Sid"),
				uin : d.get("Uin"),
				resolution : d.get("Display")
			}).then(function (g) {
				var h = require("Util"), f = [];
				e = h.extend(e, g);
				require("Util").each(e, function (i, j) {
					f.push(j + "=" + encodeURIComponent(i));
				});
				f = f.join("&");
				return f;
			});
		},
		_send : function (d) {
			require("Task").create(require("Api").get("Sid")).then(function (e) {
				if (!e) {
					a.onError({
						guid : d.guid,
						msg : "sid is Null"
					});
					return;
				}
				require("Notify").pull(c, "httpRequest", d).start();
			}).start();
		},
		loadJson : function (f) {
			var d = f, e = d.id = ++a.guid;
			this.pool[e] = d;
			require("Task").create(this.serializeParam(d.param)).then(function (g) {
				d.url += (d.url.indexOf("?") > -1 ? "&" : "?") + g;
				a._send({
					guid : e,
					method : "GET",
					url : d.url,
					supportetag : 0 == f.supportetag ? 0 : 1
				});
			}).start();
			return e;
		},
		formSubmit : function (f) {
			var d = f, e = d.id = ++a.guid;
			this.pool[e] = d;
			require("Task").create(this.serializeParam(d.param)).then(function (g) {
				a._send({
					guid : e,
					method : "POST",
					url : d.url,
					params : d.param,
					supportetag : 0 == f.supportetag ? 0 : 1
				});
			}).start();
			return e;
		}
	}, b = require("Event");
	b.on("httpSuccess", function () {
		a.onSuccess.apply(a, arguments);
	});
	b.on("httpError", function () {
		a.onError.apply(a, arguments);
	});
	return a;
});
define("ImgCache", function () {
	var b = require("Config").image, c = require("Events").eventEmitter, d = require("Collector"), a = {
		SD_PATH : null,
		LOGO_PATH : null,
		PREVIEW_PATH : null,
		AD_PATH : null,
		IS_SD_MOUNT : null,
		pathMap : {
			logo : "app",
			preview : "big_imgs",
			ad : "ad"
		},
		imgPool : {},
		listener : {},
		collector : new d(1e3, 10),
		evt : new c(),
		init : function () {
			var e = require("Event");
			e.on("loadImg", function (f) {
				f = require("$").parseJSON(f);
				f = Array.prototype.slice.call(f, 0);
				var g = {
					app : a.renderLogoCb,
					big_imgs : a.renderPreviewCb,
					ad : a.renderAdCb
				};
				f && require("Util").each(f, function (h) {
					var i = g[h.path];
					i && i.call(a, h.appid, h.path, h.localUrl, h.imgUrl);
				});
			});
			this.collector.on("fulled", this.downloadImageBatch);
		},
		on : function (e, f) {
			this.evt.on(e, f);
		},
		notify : function (e) {
			this.evt.emit.apply(this.evt, arguments);
		},
		getImgRootPath : function () {
			var f = require("Const"), e = this, g = function (h) {
				var i = "file:///";
				e.SD_PATH = i + h;
				e.LOGO_PATH = e.SD_PATH + e.pathMap.logo + "/";
				e.AD_PATH = e.SD_PATH + e.pathMap.ad + "/";
				e.PREVIEW_PATH = e.SD_PATH + e.pathMap.preview + "/";
				return true;
			};
			return f.imgRoot ? g(f.imgRoot) : require("Task").create(require("Notify").pull(b, "getImageRootPath")).then(function (h) {
				f.imgRoot = h;
				return g(h);
			});
		},
		isExist : function (e, f, g) {
			return require("Task").create(require("Notify").pull(b, [f + "", this.pathMap[e] || "", g])).then(function (h) {
				return 0 == h;
			});
		},
		getPrefix : function (e) {
			return ["http://i.gtimg.cn/open/app_icon/", ("00000000" + e).substr(-8).match(/\d{2}/g).join("/")].join("");
		},
		downLoadImg : function (e, f, g) {
			this.collector.push({
				path : a.pathMap[e] || "",
				url : f,
				del : g ? "1" : "0"
			});
		},
		downloadImageBatch : function (e) {
			require("Notify").pull(b, "downloadImageBatch", [require("$").stringify(e), 1500, 10]).start();
		},
		delImg : function (e, f, g) {
			require("Notify").pull(b, "clearImage", [e, f, g]).start();
		},
		getPic : function (e, f) {
			return a.getPrefix(e) + "/" + f;
		},
		getImgUrl : function (f, g, e) {
			return f.toLowerCase() == "ad" ? e : this.getPic(g, e);
		},
		getFileNameByUrl : function (e) {
			var f = e.lastIndexOf("/");
			return f != -1 ? e.substr(f + 1).split(".")[0] : e;
		},
		formatFileName : function (e) {
			return "img_" + e.replace(/\./ig, "_");
		},
		getCache : function (e, f, h) {
			e = e.toUpperCase();
			var g = f.lastIndexOf("."), i = g && f.substr(g) || ".png", j = a.getPicHash(e, f, h);
			return this[e + "_PATH"] + j + i;
		},
		getPicHash : function (e, f, g) {
			e = e.toUpperCase();
			(e == "PREVIEW" || e == "LOGO") && (f = a.getPic(g, f));
			var h = require("Util").hash(f);
			return h;
		},
		emptyFn : function () {
		},
		adOnload : function (e) {
			e.setAttribute("onload", "");
			e.style.display = "";
			a.notify("success", e);
		},
		adOnerror : function (f) {
			f.setAttribute("onerror", "");
			f.style.display = "none";
			var h = f.getAttribute("picid"), e = f.getAttribute("picurl"), i = a.getFileNameByUrl(e);
			f.onerror = function () {
				this.onerror = null;
				a.notify("error", h, a.pathMap.ad, e);
				e && a.delImg("", a.pathMap.ad, e);
			};
			var g = require("Util").hash(e);
			if (a.imgPool[g] == 1) {
				return;
			}
			a.imgPool[g] = 1;
			e && a.downLoadImg("ad", e, true);
		},
		renderAdCb : function (f, i, e, g) {
			if (e) {
				a.imgPool[a.getFileNameByUrl(e)] = 0;
				var h = "img_" + a.getFileNameByUrl(e);
				require("$")("." + h).each(function () {
					!this.getAttribute("loaded") && (this.setAttribute("src", "file:///" + e), this.setAttribute("loaded", 1));
				});
			} else {
				a.notify("error", f, a.pathMap.ad, g);
			}
		},
		previewOnload : function (e) {
			e.setAttribute("onload", "");
			e.style.display = "";
			a.notify("success", e);
			var f = e.getAttribute("picid"), h = e.getAttribute("picname"), g = a.getPic(f, h);
			f && g && a.downLoadImg("preview", g);
		},
		previewOnerror : function (f) {
			f.setAttribute("onerror", "");
			f.style.display = "none";
			var h = f.getAttribute("picid"), i = f.getAttribute("picname"), e = a.getPic(h, i);
			f.onerror = function () {
				this.onerror = null;
				a.notify("error", "", a.pathMap.preview, e);
				e && a.delImg("", a.pathMap.preview, e);
			};
			var g = require("Util").hash(e);
			if (a.imgPool[g] == 1) {
				return;
			}
			a.imgPool[g] = 1;
			e && a.downLoadImg("preview", e, true);
		},
		renderPreviewCb : function (f, i, e, g) {
			if (e) {
				a.imgPool[a.getFileNameByUrl(e)] = 0;
				var h = "img_" + a.getFileNameByUrl(e);
				require("$")("." + h).each(function () {
					!this.getAttribute("loaded") && (this.onload = function () {
						this.onload = null;
						this.style.display = "";
						a.notify("success", this);
					}, this.setAttribute("src", "file:///" + e), this.setAttribute("loaded", 1));
				});
			} else {
				a.notify("error", f, a.pathMap.preview, g);
			}
		},
		logoOnload : function (e) {
			e.setAttribute("onload", "");
			e.style.display = "";
			var g = e.getAttribute("picid"), i = e.getAttribute("picname"), f = a.getPic(g, i);
			e.src.indexOf("defaultlogo.png") > -1 && (e.onerror = function () {
				this.onerror = null;
				this.src = "defaultlogo.png";
				g && f && a.delImg("", a.pathMap.logo, f);
			});
			if (e.getAttribute("loadDef") != 1) {
				var h = require("Util").hash(f);
				if (a.imgPool[h] == 1) {
					return;
				}
				a.imgPool[h] = 1;
				g && f && a.downLoadImg("logo", f);
			}
		},
		logoOnerror : function (e) {
			e.style.display = "none";
			e.setAttribute("onerror", "");
			var g = e.getAttribute("picid"), i = e.getAttribute("picname"), f = a.getPic(g, i);
			if (e.src.indexOf("defaultlogo.png") < 0) {
				var h = require("Util").hash(f);
				e.onerror = function () {
					this.onerror = null;
				};
				e.src = "defaultlogo.png";
				if (a.imgPool[h] == 1) {
					return;
				}
				a.imgPool[h] = 1;
				g && f && a.downLoadImg("logo", f, true);
			}
		},
		renderLogoCb : function (g, h, e, i) {
			if (e) {
				a.imgPool[a.getFileNameByUrl(e)] = 0;
				var f = "img_" + a.getFileNameByUrl(e);
				require("$")("." + f).each(function () {
					!this.getAttribute("loaded") && (this.onload = function () {
						this.onload = null;
					}, this.setAttribute("src", "file:///" + e), this.setAttribute("loaded", 1));
				});
			}
		},
		getPicTmpl : function (e) {
			e = e || {};
			var f = "";
			switch (e.type.toLowerCase()) {
				case "logo":
					if (e.picid) {
						var g = e.picid + "_100_m.png";
						f = require("Str").tmpl("<img src='<%= loadDef ? 'defaultlogo.png' : require('ImgCache').getCache( 'logo', picname, picid )%>' onload='require(\"ImgCache\").logoOnload(this)' onerror='require(\"ImgCache\").logoOnerror(this)' picid='<%=picid%>' loadDef='<%=loadDef%>' pictype='LOGO' picname='<%=picname%>' class='<%=className%> img_<%=require('ImgCache').getPicHash( 'logo', picname, picid )%> j_for_switch_mode j_for_render_pic'>", {
							picid : e.picid,
							picname : g,
							className : e.className || "",
							loadDef : e.loadDef ? 1 : 0
						});
					}
					break;
				case "preview":
					e.picid && e.picname && (f = require("Str").tmpl("<img src='<%=require('ImgCache').getCache( 'preview', picname, picid )%>' onload='require(\"ImgCache\").previewOnload(this)' onerror='require(\"ImgCache\").previewOnerror(this)' class='j_for_switch_mode j_for_render_pic img_<%=require('ImgCache').getPicHash( 'preview', picname, picid )%>' picid='<%=picid%>' pictype='PREVIEW' picname='<%=picname%>' <%=extendAttr%> >", {
						picid : e.picid,
						picname : e.picname,
						extendAttr : e.extendAttr || ""
					}));
					break;
				case "ad":
					e.picid && e.picurl && (f = require("Str").tmpl("<img src='<%=require('ImgCache').getCache( 'ad', picurl )%>' onload='require(\"ImgCache\").adOnload(this)' onerror='require(\"ImgCache\").adOnerror(this)' class='j_for_render_pic img_<%=require('ImgCache').getPicHash( 'ad', picurl )%>' picid='<%=picid%>' pictype='AD' picurl='<%=picurl%>' <%=extendAttr%> >", {
						picid : e.picid,
						picurl : e.picurl,
						extendAttr : e.extendAttr || ""
					}));
					break;
			}
			return f;
		}
	};
	a.init();
	return a;
});
define("Stat", function () {
	var c = require("Collector"), a = new c(2e3, 10), b = {
		reportBatch : function (d) {
			setTimeout(function () {
				require("Notify").pull(require("Config").client, "reportForViaBatch", [require("$").stringify(d)]).start();
			}, 0);
		},
		send : function (d, e, f) {
			a.push({
				actionType : d,
				via : e,
				appid : (f || require("Const").appid) + "",
				jsversion : require("M").JSVersion || "0"
			});
		},
		exposure : function (d, e) {
			this.send("100", d, e);
		},
		click : function (d, e) {
			this.send("200", d, e);
		},
		setup : function (d, e) {
			this.send("300", d, e);
		},
		setupWebApp : function (d, e) {
			setTimeout(function () {
				require("Notify").pull(require("Config").client, "reportStartApp", {
					via : d,
					appid : e + "",
					jsversion : require("M").JSVersion || "0",
					sender : 0
				}).start();
			}, 50);
		},
		startApp : function (d, e) {
			this.send("500", d, e);
		},
		autoStartApp : function (d, e) {
			this.send("502", d, e);
		},
		cancelClick : function (d, e) {
			this.send("700", d, e);
		},
		download : function (d, e) {
			this.send("900", d, e);
		},
		unInstall : function (d, e) {
			this.send("1000", d, e);
		},
		update : function (d, e) {
			this.send("2000", d, e);
		}
	};
	a.on("fulled", b.reportBatch);
	return b;
});
define("Storage", function () {
	var a = require("Database"), b = require("Config").db, c = {
		name : require("TableConfig").app_cache.name,
		getItem : function (d) {
			var e = require("LocalStorage");
			if (e.support) {
				return e.get(d);
			} else {
				return require("Task").create(a.select({
					select : "v",
					from : c.name,
					where : {
						k : d
					}
				})).then(function (f) {
					f = require("$").parseJSON(f);
					return f && f.length > 0 ? f[0][0] : "";
				});
			}
		},
		setItem : function (d, e) {
			var f = require("LocalStorage");
			f.support ? f.set(d, e) : a.update({
				into : this.name,
				values : {
					k : d,
					v : e
				}
			});
		},
		delItem : function (d) {
			a.del({
				from : this.name,
				where : {
					k : d
				}
			});
		},
		getMemValue : function (d) {
			return require("Notify").pull(b, "getMemValue", [d]);
		},
		setMemValue : function (d, e) {
			require("Notify").pull(b, "setMemValue", [d, e]).start();
		}
	};
	return c;
});
define("StorageMap", {
	message : "message_",
	need_new : "need_new_",
	finish_guide : "finish_guide_",
	social_max_count : "social_max_count_",
	myNotifyCount : "myNotifyCount_"
});
define("TableConfig", {
	app_cache : {
		name : "app_cache",
		version : 3,
		sql : "create table app_cache (k varchar(50) PRIMARY KEY,v text);"
	},
	category : {
		name : "category",
		version : 6,
		sql : "create table category (id varchar(50) PRIMARY KEY,v text);"
	},
	app : {
		name : "app",
		version : 8,
		sql : "create table app (id INTEGER PRIMARY KEY,v text,imid varchar(30), pName varchar(200), ext text);"
	},
	user_info : {
		name : "user_info",
		version : 2,
		sql : "create table user_info (id INTEGER(50), code INTEGER, friends TEXT, feeds TEXT, info TEXT,primary key (id,code));"
	}
});
define("Update", function () {
	var a = "http://mapp.qzone.qq.com", b = {
		url : a + "/cgi-bin/mapp/mapp_data",
		infourl : a + "/cgi-bin/mapp/mapp_info",
		privacyurl : a + "/cgi-bin/mapp/mapp_privacy",
		urlMap : {
			home : a + "/cgi-bin/mapp/mapp_home_qq",
			latest_used_app : a + "/cgi-bin/mapp/mapp_latest_used_app",
			hotnogame : a + "/cgi-bin/mapp/mapp_cate_qq",
			myapplist_v2 : a + "/cgi-bin/mapp/mapp_mylist_qq",
			report : a + "/cgi-bin/mapp/mapp_report"
		},
		updateTime : null,
		LOADLOCALDATA : true,
		BYDAY : false,
		CACHETIME : 1e3 * 60 * 30,
		KEY : {
			home : "home",
			rec : "recommend",
			indexadv : "indexadvs",
			hotnogame : "hotnogame",
			latestUsedApp : "latest_used_app",
			myapp : "myapplist",
			myapp_v2 : "myapplist_v2",
			notify : "notify",
			message : "message"
		},
		needRefresh : false,
		retKey : {
			apps : "app",
			social : "social",
			advs : "advs",
			notify : "notify",
			message_count : "message_count",
			latestUsedApp : "latestUsedApp",
			updateapp : "updateapp",
			reportRate : "reportRate"
		},
		page : {},
		pageSize : 20,
		getUpdateTime : function () {
			if (!this.updateTime) {
				return require("Task").create(require("Storage").getItem("dataUpdateTime")).then(function (c) {
					c = c ? require("$").parseJSON(c) : {};
					b.updateTime = c;
					return c;
				});
			}
			return this.updateTime;
		},
		saveUpdateTime : function () {
			require("Storage").setItem("dataUpdateTime", require("$").stringify(this.updateTime));
		},
		isNeedUpdate : function (e, d) {
			d = d || 1;
			var c = this, f = this.KEY.message == e ? this.MSG_CACHETIME : this.CACHETIME;
			return require("Task").create(this._resetKey(e)).then(function (g) {
				!c.updateTime[g] && (c.updateTime[g] = {});
				var i = new Date(c.updateTime[g][d] || 0), j = new Date(), h = 0, k = function (l) {
					return l.getFullYear() + "-" + (l.getMonth() + 1) + "-" + l.getDate();
				}, h = j > i && j - i > c.CACHETIME ? 1 : 0;
				return h;
			});
		},
		setUpdateTime : function (e, f, d) {
			var c = this;
			require("Task").create(this._resetKey(e)).then(function (g) {
				!c.updateTime[g] && (c.updateTime[g] = {});
				c.updateTime[g][f] = d && d * 1e3 || Date.now();
			}).start();
		},
		_resetKey : function (c) {
			return require("Task").create(require("Api").get("Uin")).then(function (e) {
				var d = b.KEY;
				c = (new RegExp("^(" + d.indexadv + "|" + d.gamelistadv + "|" + d.nogamelistadv + ")$")).test(c) ? c : c + "_" + e;
				return c;
			});
		},
		_updateCategoryData : function (e, f, g, c, h, i) {
			var d = require("Category");
			require("Task").create(d.getCategory(c)).then(function (k) {
				var m = d.id, l = e && e.length || 0, j = [];
				if (l > 0 || c == m.updateapp) {
					require("App").add(e);
					require("Util").each(e, function (p) {
						p && j.push(p.id);
					});
					if (h) {
						d.setCategory(c, j);
					} else {
						var n = Math.max(0, f - 1) * g;
						Array.prototype.splice.apply(k, [n, l].concat(j));
						d.setCategory(c, k);
					}
					d.setCateNext(c, f, i);
				}
			}).start();
		},
		_updateData : function (i, k, d, f, u) {
			var v = require("Util"), l = require("$"), c = {}, m = this, h = this.retKey, g = this.KEY, n = require("Category").id, q = "";
			v.each(h, function (e) {
				c[e] = f[e];
			});
			var s = n[i], d = d || this.page[i];
			switch (i) {
				case g.home:
					var r = c[h.apps] || [], j = c[h.advs] || [];
					this._updateCategoryData(r, d, k, s, c.overwrite, f.next);
					j.length > 0 && (require("Storage").setItem(g.indexadv, l.stringify(j)), this.setUpdateTime(g.indexadv, 1, f.time));
					this.setUpdateTime(i, d, f.time);
					break;
				case g.hotnogame:
					!q && (q = g.nogamelistadv);
					var r = c[h.apps] || [], j = c[h.advs] || [];
					this._updateCategoryData(r, d, k, s, c.overwrite, f.next);
					j.length > 0 && (require("Storage").setItem(q, l.stringify(j)), this.setUpdateTime(q, 1, f.time));
					this.setUpdateTime(i, d, f.time);
					break;
				case g.latestUsedApp:
					var t = c[h.latestUsedApp] || [], w = c[h.updateapp] || [], x = [];
					this._updateCategoryData(w, d, k, n.updateapp, true, f.next);
					d == 1 && (c.overwrite = true, v.each(t, function (e) {
						!!e.ismultipf && x.push(e);
					}), this._updateCategoryData(x, d, k, n.myapp_pc, c.overwrite, f.next));
					this._updateCategoryData(t, d, k, s, c.overwrite, f.next);
					var y = [].concat(t, w);
					y.length > 0 && this.setUpdateTime(i, d, f.time);
					break;
				case g.myapp_v2:
					var m = this, p = c[h.notify] || {
						update : [],
						pcapp : []
					}, z = c[h.message_count] || 0;
					require("Task").create(require("Category").getCategory(n.updateapp)).then(function (e) {
						var e = e || [];
						p && !u.message_only && (require("Task").create(require("Api").get("Uin")).then(function (B) {
							require("Storage").setItem(n.notify + B, l.stringify(p));
						}).start(), m.setUpdateTime(g.notify, d, f.time));
						u.need_message && (require("Task").create(require("Api").get("Uin")).then(function (B) {
							require("Storage").setItem(require("StorageMap").message + B, l.stringify(z));
						}).start(), m.setUpdateTime(g.message, d, f.time));
						p.update = p.update || [];
						p.update.length !== e.length && m.setUpdateTime(g.latestUsedApp, 1, 2649600);
					}).start();
					break;
			}
			this.saveUpdateTime();
			if (c.reportRate) {
				try {
					require("Task").create(require("Api").get("Uin")).then(function (e) {
						window.localStorage && localStorage.setItem("reportRate_" + e, encodeURIComponent(l.stringify(c.reportRate)));
					}).start();
				} catch (A) {
				}
				require("M").stringReport.reportRate = parseInt(c.reportRate);
			}
		},
		getLocalData : function (e, k) {
			var h = require("$"), i = require("App"), l = require("Category"), f = this.KEY, j = l.id, s = this, c = {}, g = j[e], d = k.pageNo, p = k.pageSize, r = "", q = require("DfData"), m = false;
			c.dataVerify = true;
			var n = function () {
				!c.dataVerify && s.saveUpdateTime();
				c.loadDefdata = m;
				return c;
			};
			switch (e) {
				case f.home:
					return require("Task").create().map({
						app : i.getAppsByCate(g, d, p, false),
						advs : require("Storage").getItem(f.indexadv),
						next : l.getCateNext(g, d)
					}).then(function (t) {
						c.app = t.app || [];
						c.advs = h.parseJSON(t.advs) || [];
						c.next = t.next;
						c.app.length == 0 && 1 == d && (m = true, c.app = q.home || []);
						0 == c.advs.length && (m = true, c.advs = q.indexadv || []);
						0 == c.app.length && (c.dataVerify = false, b.setUpdateTime(e, d, 2649600));
						return n();
					});
				case f.hotnogame:
					!r && (r = f.nogamelistadv);
					return require("Task").create().map({
						app : i.getAppsByCate(g, d, p, false),
						advs : require("Storage").getItem(f.indexadv),
						next : l.getCateNext(g, d)
					}).then(function (t) {
						c.app = t.app || [];
						c.advs = h.parseJSON(t.advs) || [];
						c.next = t.next;
						20 != c.app.length && 10 != c.app.length && 1 == d && (m = true, c.app = q[e] || []);
						0 == c.app.length && (c.dataVerify = false, b.setUpdateTime(e, d, 2649600));
						return n();
					});
				case f.latestUsedApp:
					return require("Task").create(require("Api").get("Uin")).map(function (t) {
						return {
							notify : require("Storage").getItem(j.notify + t),
							latestUsedApp : i.getAppsByCate(g, d, p),
							updateapp : i.getAppsByCate(j.updateapp),
							myappPc : i.getAppsByCate(j.myapp_pc),
							need : b.isNeedUpdate(e, d),
							next : l.getCateNext(g, d)
						};
					}).then(function (t) {
						c.notify = h.parseJSON(t.notify) || {
							update : [],
							pcapp : []
						};
						c.latestUsedApp = t.latestUsedApp || [];
						c.updateapp = t.updateapp || [];
						c.myappPc = t.myappPc || [];
						c.next = t.next;
						0 == [].concat(c.latestUsedApp, c.updateapp) && t.need && (c.dataVerify = false, b.setUpdateTime(e, d, 2649600));
						return n();
					});
				case f.myapp_v2:
					return require("Task").create(require("Api").get("Uin")).map(function (t) {
						return {
							notify : require("Storage").getItem(j.notify + t),
							message_count : k.need_message ? require("Storage").getItem(require("StorageMap").message + t) : 0
						};
					}).then(function (t) {
						c.notify = h.parseJSON(t.notify) || {
							update : [],
							pcapp : []
						};
						k.need_message && (c.message_count = h.parseJSON(t.message_count) || 0);
						return n();
					});
			}
		},
		loadData : function (c, z) {
			var r = require("$"), l = require("Util"), i = require("Task"), u = require("Api"), m = require("Category"), g = z || {}, h = this, d = this.KEY, v = this.retKey, s = m.id, e = g.param || {}, n = e.pageSize || this.pageSize, w = !!e.pageNo, p = "", q = false, j = false, A = false;
			!this.page[c] && (this.page[c] = 0);
			var f = e.pageNo || this.page[c] + 1, t, k, B = e.need_message || 0;
			i.create(this.getUpdateTime()).then(function () {
				if (d.myapp_v2 == c && e.notify_only) {
					return i.create().map({
						need_notify : h.isNeedUpdate(d.notify, 1),
						need_message : e.need_message ? h.isNeedUpdate(d.message, 1) : false
					}).then(function (C) {
						!C.need_notify && C.need_message && (k = 1);
						return C.need_notify || C.need_message;
					});
				} else {
					return h.isNeedUpdate(c, f);
				}
			}).map(function (C) {
				t = C;
				return {
					need : t,
					mobileInfo : u.getMobileInfo()
				};
			}).then(function (D) {
				e = l.extend({
					type : c,
					pageNo : f,
					pageSize : n,
					need_advertise : d.home == c ? 1 : 0
				}, g.param);
				if (d.myapp_v2 == c || d.home == c || d.latestUsedApp == c) {
					var C = D.mobileInfo;
					e = l.extend({
						imei : C.imei,
						mac_addr : C.wifimac,
						model_info : C.model_name || "",
						network_type : C.network || "",
						network_operater : C.mobileType || "",
						location : C.location || "",
						imsi : C.imsi || "",
						android_id : C.androidID || ""
					}, e);
				}
				i.create(y()).then(function (E) {
					E && t && x();
				}).start();
			}).start();
			var x = function () {
				if (q) {
					return;
				}
				q = true;
				var F = false;
				e.firsttime = 0;
				switch (c) {
					case d.rec:
					case d.home:
						p = d.indexadv;
						e.need_friends = 1;
						break;
					case d.hotnogame:
						p = d.nogamelistadv;
						break;
					case d.latestUsedApp:
					case d.myapp:
					case d.myapp_v2:
						break;
				}
				var D = function (G) {
					if (0 == G.resultCode) {
						var M = require("App"), I = require("Storage"), N = require("StorageMap"), J, K, L;
						newList = [];
						i.create().map({
							uin : u.get("Uin"),
							oldList : m.getCategory(s[c], f, n),
							oldAdvs : 1 === e.need_advertise && !G.advs && p && I.getItem(p),
							notify_resetKey : h._resetKey(d.notify)
						}).then(function (O) {
							J = O.oldList;
							L = O.notify_resetKey;
							K = r.parseJSON(O.oldAdvs) || [];
							!w && (h.page[c] = f);
							d.home == c && f == 1 && (G.social = G.social || [], G.app = G.social.concat(G.app), I.setItem(N.social_max_count + O.uin, G.social.length));
							h._updateData(c, n, f, G, {
								message_only : k,
								need_message : B
							});
							1 === e.need_advertise && !G.advs && p && (G.advs = K);
							if (d.myapp_v2 == c && e.notify_only) {
								j = false;
								i.create(k && I.getItem(L)).then(function (Q) {
									k && (G.notify = Q && r.parseJSON(Q) || {
										update : [],
										pcapp : []
									});
									!k && (h.setUpdateTime(d.myapp_v2, 1, 2649600), h.saveUpdateTime());
									H();
								}).start();
								G.latest_num && require("LocalStorage").set("latest_num", G.latest_num);
							} else if (d.latestUsedApp == c) {
								i.create().map({
									data_notify : I.getItem(L),
									updateApps : m.getCategory(s.updateapp)
								}).then(function (Q) {
									G.notify = r.parseJSON(Q.data_notify) || {};
									var R = G[v.latestUsedApp], S = [], U = Q.updateApps || [], T = [];
									l.each(R, function (V) {
										V.id && newList.push(V.id);
										!!V.ismultipf && T.push(V);
									});
									f == 1 && (G.myappPc = T, l.each(G[v.updateapp], function (V) {
										V.id && S.push(V.id);
									}));
									J.join(",") != newList.join(",") || f == 1 && U.join(",") != S.join(",") ? (u.setUrlParam("refresh", "0"), G.overwrite = 1, G.pageNo = f, j = false, f > 1 ? i.create(m.getCategory(s[c])).then(function (V) {
										V = V.slice(0, Math.max(0, f - 1) * n);
										return M.getAppsByIds(V);
									}).then(function (V) {
										G.latestUsedApp = V.concat(R);
										H();
									}).start() : H()) : H();
								}).start();
								G.latest_num && require("LocalStorage").set("latest_num", G.latest_num);
							} else {
								d.home == c && I.setItem(N.need_new + O.uin, 1);
								var P = G.app;
								l.each(P, function (Q) {
									Q.id && newList.push(Q.id);
								});
								!K && f == 1 && G.advs && G.advs.length > 0 && (G.overwrite = 1, G.pageNo = f, j = false);
								J.join(",") != newList.join(",") ? (G.overwrite = 1, G.pageNo = f, j = false, f > 1 ? i.create(m.getCategory(s[c])).then(function (Q) {
									Q = Q.slice(0, Math.max(0, f - 1) * n);
									return M.getAppsByIds(Q);
								}).then(function (Q) {
									G.app = Q.concat(P);
									H();
								}).start() : H()) : H();
							}
						}).start();
						var H = function () {
							h.needRefresh && (j = false);
							G.__isFromLocal = 0;
							!j && g.success && g.success.call(null, G);
							j = true;
							q = false;
						};
					} else {
						C(G);
						q = false;
					}
				}, C = function (G) {
					G.__isFromLocal = 0;
					!j && (h.LOADLOCALDATA && !g.errorFromLocal ? (g.errorfromServer = true, y()) : g.error && g.error.call(null, G), j = true);
					q = false;
				};
				if (d.myapp_v2 == c && !k || d.latestUsedApp == c) {
					var E = function () {
						require("Http").formSubmit({
							url : h.urlMap[c],
							param : e,
							success : D,
							error : C
						});
					};
					!k ? i.create(require("App").getInstalledApp()).then(function (I) {
						var G = require("LocalAppFileds"), H = [];
						l.each(I, function (J) {
							H.push([J[G.pName] || "", J[G.versionCode] || "", J[G.versionName] || ""]);
						});
						e["package"] = r.stringify(H);
						E();
					}).start() : E();
				} else {
					require("Http").loadJson({
						url : h.urlMap[c],
						param : e,
						success : D,
						error : C
					});
				}
			}, y = function (C) {
				return i.create(h.getLocalData(c, e)).then(function (D) {
					D.__isFromLocal = 1;
					if (D.dataVerify) {
						j = true;
						A = D.loadDefdata;
						!w && (h.page[c] = f);
						g.success && g.success.call(null, D, t);
						return true;
					} else {
						!g.errorfromServer ? (g.errorFromLocal = true, x()) : g.error && g.error.call(null, D);
						return false;
					}
				});
			};
		},
		setPrivacyData : function (d, c) {
			require("Http").formSubmit({
				url : this.privacyurl,
				param : {
					appid : d.id
				},
				success : function (e) {
					0 == e.resultCode ? (d.friends.myprivacy = 1, require("App").add(d), c.success && c.success.call(null, e)) : c.error && c.error.call(null, e);
				},
				error : function (e) {
					c.error && c.error.call(null, e);
				}
			});
		},
		getAppFromServer : function (d, e) {
			var f = require("Util"), c = e || {}, g = f.extend({
				type : "appinfo",
				appid : d
			}, c.param);
			d && require("Http").loadJson({
				url : this.infourl,
				param : g,
				success : function (h) {
					var i = require("App");
					0 == h.resultCode ? require("Task").create(i.getAppById(d)).then(function (k) {
						var j = h.app && h.app[0] || {};
						k = k || {};
						h.friendsplayed && (j.friends = h.friendsplayed[0] || {});
						j.id ? (delete j.playCount, j.userCount = Math.max(j.userCount, k.userCount || 0), i.add(j), c.success && c.success.call(null, h)) : (h.msg = "找不到这个应用哦", require("M").stringReport({
							errMsg : "Api.update.getAppFromServer appid : " + d + " load error. the appinfo in result is illegal",
							code : -502,
							duration : 0
						}), c.error && c.error.call(null, h));
					}).start() : c.error && c.error.call(null, h);
				},
				error : function (h) {
					c.error && c.error.call(null, h);
				}
			});
		},
		userAddApp : function (c, e, d) {
			if (c) {
				e ? require("Stat").setupWebApp(e, c) : require("Task").create(require("Api").get("Uin")).map(function (f) {
					return {
						uin : f,
						isReport : require("Storage").getItem("record_" + c + "_" + f)
					};
				}).then(function (f) {
					if (d == "install") {
						if (f.isReport) {
							return;
						} else {
							require("Storage").setItem("record_" + c + "_" + f.uin, 1);
						}
					}
					require("Http").loadJson({
						url : "http://mapp.qzone.qq.com/cgi-bin/mapp/mapp_report",
						param : {
							type : "latest_used_app",
							appid : c,
							action : d && encodeURIComponent(d) || ""
						},
						success : function (g) {
							0 == g.resultCode;
						}
					});
				}).start();
				return true;
			} else {
				return false;
			}
		}
	};
	return b;
});
define("Init", function () {
	var a = {
		start : function () {
			window.JsBridge = require("JsBridge");
			window.QzoneApp = require("QzoneApp");
			require(["DownloadBtn", "TapEvent"]);
		}
	};
	return a;
});
define("DownloadBtn", function () {
	var a = {
		D_BTN : ".pro_",
		D_PRO : " .d_pro",
		D_PRO_TEXT : " .d_pro_text",
		D_TEXT : " .d_text",
		D_STATE : " .d_state",
		D_SEARCH : " .d_search",
		MSG : {
			"-1" : "当前安装包出现问题或已被删除,请重新下载！",
			"-2" : "下载出错，请重试！",
			"-3" : "未发现存储卡，请检查后重试！",
			"-4" : "下载地址已更新,请重新下载！",
			"-5" : "网络无法连接，请检查网络并重试！",
			"-6" : "存储卡空间不足，请释放空间后重试！"
		},
		TEXT : {
			PAUSE : "暂停",
			DOWNLOAD : "下载",
			CONTINUE : "继续",
			INSTALL : "安装",
			UPDATE : "更新",
			START : "进入",
			WAIT : "等待中"
		},
		SEARCH_BTN : {
			"暂停" : "ico-stop",
			"下载" : "ico-download",
			"继续" : "ico-start",
			"安装" : "ico-set",
			"更新" : "ico-reflash",
			"进入" : "ico-open",
			"等待中" : "ico-stop",
			"下载中" : "ico-stop"
		},
		DEFALUT : true,
		init : function () {
			var b = require("Download");
			b.addListener(b.STATE.ALL, function (c, d) {
				a.showState(c, d);
			});
		},
		preventDefault : function () {
			this.DEFALUT = false;
		},
		setText : function (g, b, c) {
			100 <= c && (c = 100.5);
			var d = this.D_BTN + g, f = this.SEARCH_BTN[b.indexOf("%") > -1 ? this.TEXT.PAUSE : b], e = require("$");
			e(d + this.D_TEXT).html(b);
			e(d + this.D_PRO).css("width", c + "%");
			e(d + this.D_PRO_TEXT).html((c >= 100 ? 100 : c) + "%");
			e(d + this.D_STATE).html(b.indexOf("%") > -1 ? this.TEXT.PAUSE : b);
			f && e(d + this.D_SEARCH).overWriteClass([this.D_SEARCH.replace(/\s?\./, ""), f].join(" "));
		},
		updateProc : function (c, b, d) {
			var e = parseInt(require("$")(this.D_BTN + c + this.D_TEXT).html()) || 0;
			!(e && b < e) && this.setText(c, d ? "下载中" : b + "%", d ? 100 : b);
		},
		_isShowIng : false,
		_showToast : function (b) {
			!this._isShowIng && (this._isShowIng = true, require("Api").showMsg(b), setTimeout(function () {
				a._isShowIng = false;
			}, 3e3));
		},
		showState : function (f, p) {
			if (!this.DEFALUT) {
				return;
			}
			var i = require("App"), g = require("Download"), d = g.STATE, j = g.PSTATE, b = f.appid, k = f.state, e = f.pro || 0, n = parseInt(f.phony_pro) || 0, h = g.getProState(b), l = f.ismyapp, c = this;
			e = Math.max(e, n);
			isNaN(e) && (e = 0);
			var m = function () {
				var q = j.INSTALL == h;
				q && (b = 0 - b);
				var r = require("$")(c.D_BTN + b);
				if (k != d.SETUP_END && r.length < 0) {
					return false;
				}
				switch (k) {
					case d.DOWN:
						c.updateProc(b, e, l);
						break;
					case d.PAUSE:
						c.setText(b, c.TEXT.CONTINUE, l ? 100 : e);
						break;
					case d.DOWN_END:
						c.setText(b, c.TEXT.INSTALL, 100);
						break;
					case d.SETUP_END:
					case d.PACKAGE_REPLACE:
						c.setText(b, c.TEXT.START, 0);
						break;
					case d.UNINSTALL_END:
					case d.CANCEL:
						c.setText(b, q ? c.TEXT.UPDATE : c.TEXT.DOWNLOAD, 0);
						break;
					case d.WAIT:
						c.setText(b, c.TEXT.WAIT, 0);
						break;
				}
			};
			!h ? require("Task").create(i.getAppById(b)).then(function (q) {
				if (q && q.pName) {
					return i.isInstall(q.pName);
				} else {
					return this.reject();
				}
			}).then(function (q) {
				var r = i.getAppById(b);
				h = q ? j.INSTALL : j.UNINSTALL;
				g.updateProState(b, h, true);
				m();
			}).start() : m();
		}
	};
	a.init();
	return a;
});
define("Page", function () {
	var a = {
		touchTimer : null,
		dialogShowed : false,
		_preEvt : function (b) {
			b && (b.stopPropagation(), b.preventDefault());
		},
		detail : function (d, e) {
			var b = e || {};
			this._preEvt(d);
			var c = ["sd://detail.htm?id=" + b.appid];
			b.channelId = b.channelId || require("Const").channelId;
			b.openTime = Date.now();
			b.channelId == require("Channel").HOMESOCIAL && (b.socialPos = b.rank);
			require("Util").each(b, function (f, g) {
				c.push(encodeURIComponent(g) + "=" + encodeURIComponent(f));
			});
			b.url = c.join("&");
			require("Task").create(require("Via").getChannelVia(b.channelId)).then(function (f) {
				b.pName && !/^[234]$/.test(b.tyqtype) ? (b.via = f, b.myAppId = parseInt(b.myAppId, 10) == 0 ? "" : b.myAppId, b.apkId = parseInt(b.apkId, 10) == 0 ? "" : b.apkId, require("Api").goToDetailPage(b)) : require("Api").openLocalUrl({
					url : c.join("&"),
					titleInfo : [{
						name : "应用详情",
						tipNum : 0
					}]
				});
				b.rank && b.rank < 51 && require("Task").create(require("Via").getPageVia(b.channelId)).then(function (g) {
					require("Stat").click(g + ".BLOCK." + b.rank, b.appid);
				}).start();
			}).start();
			return false;
		},
		ad : function (d, e) {
			var b = e || {};
			this._preEvt(d);
			b.type = b.type || 0;
			var f = {
				0 : "",
				1 : "sd://detail.htm"
			}[b.type] || "", g = {
				0 : "",
				1 : "应用详情"
			}[b.type], c = f + (b.appurl.indexOf("?") > -1 ? "" : "?") + b.appurl;
			c += (c.indexOf("?") > -1 ? "&" : "?") + "channelId=" + b.channelId + "&adId=" + b.adId;
			b.type == 1 ? (b.url = c, require("Task").create(require("Via").getChannelVia(b.channelId)).then(function (h) {
				b.via = h;
				b.appid = b.adId;
				require("Api").goToDetailPage(b);
			}).start()) : b.appurl && require("Api").openUrl({
				url : c,
				titleInfo : [{
					name : g,
					tipNum : 0
				}]
			});
			return false;
		},
		icon : function (d, e) {
			var b = e || {};
			this._preEvt(d);
			var c = require("App");
			b.pName ? require("Task").create(c.isInstall(b.pName)).then(function (f) {
				f ? c.startApp(b) : a.detail(d, b);
			}).start() : c.goWebApp(b);
			return false;
		},
		category : function (c, d) {
			var b = d || {};
			this._preEvt(c);
			var e = "category.htm?type=" + b.type + "&channelId=" + (b.channelId || require("Const").channelId) + "&openTime=" + Date.now(), f = {
				nogame : [{
					name : "全部应用",
					tipNum : 0
				}]
			}, g = f[b.type];
			return require("Api").openLocalUrl({
				url : e,
				current : b.current,
				titleInfo : g
			});
		},
		info : function (b, c) {
			this._preEvt(b);
			require("Api").openLocalUrl({
				url : "apps.html?channelId=10000&openTime=" + Date.now(),
				titleInfo : [{
					name : "应用消息",
					tipNum : 0
				}]
			});
		},
		myapp : function (c, d) {
			var b = d || {};
			this._preEvt(c);
			require("Api").openLocalUrl({
				url : "myapp.htm?type=" + b.type + "&index=" + b.current + "&channelId=" + (b.channelId || require("Const").channelId) + "&openTime=" + Date.now(),
				titleInfo : [{
					name : "我的应用",
					tipNum : 0
				}]
			});
		},
		btn : function (e, f) {
			var b = f || {};
			this._preEvt(e);
			var c = require("App"), d = function () {
				b.rank && b.rank < 51 && require("Task").create(require("Via").getPageVia(b.channelId)).then(function (g) {
					require("Stat").click(g + ".DOWNLOAD." + b.rank, b.appid);
				}).start();
			};
			b.pName ? require("Task").create(require("Download").go(b)).then(function (g) {
				g && (g == "isInstall" ? c.startApp(b) : location.reload());
				d();
			}).start() : (c.goWebApp(b), d());
			return false;
		},
		update : function (c, d) {
			var b = d || {};
			this._preEvt(c);
			require("Task").create().map(function () {
				return {
					isInstall : require("App").isInstall(b.pName)
				};
			}).then(function (e) {
				b.isUpdate = true;
				require("Task").create(require("Download").go(b)).then(function (f) {
					f && (e.isInstall ? App.startApp(b) : location.reload());
				}).start();
			}).start();
		},
		reportErrMsg : function (c, d, f, g) {
			var b = "";
			c && (c.stack && (b = c.stack.split("\n"), b = b.slice(0, 5).join("\n")), b = (g || "") + (b || c.message));
			b && require("M").stringReport({
				errMsg : b,
				code : d,
				duration : f
			});
		},
		disActive : function (c) {
			var d = require("$"), b = d(this);
			c.type == "touchmove" && (clearTimeout(this.touchTimer), b.removeClass("active"), b.unbind("touchmove", a.disActive).unbind("touchend", a.disActive));
			b.unbind("touchmove", a.disActive).unbind("touchend", a.disActive);
			window.setTimeout(function () {
				b.removeClass("active");
			}, 200);
		},
		bindBtnActiveEvt : function (b, c) {
			require("Util").delegate(b, "touchstart", function (f) {
				var g = require("$"), d = g(this);
				f.stopPropagation();
				d.bind("touchmove", a.disActive).bind("touchend", a.disActive);
				this.touchTimer = setTimeout(function () {
					d.addClass("active");
				}, 100);
			}, c);
		},
		getDocWidth : function () {
			return require("Task").create(require("Api").get("Display")).then(function (b) {
				var c = document.documentElement.clientWidth, b = b.split("x"), d = (b[0] || 0) / (devicePixelRatio || 1);
				return c == d ? c : d;
			});
		},
		unique : function (c) {
			var b = [];
			require("Util").each(c, function (d) {
				b.indexOf(d) == -1 && b.push(d);
			});
			return b;
		},
		getInstallMap : function (d) {
			var c = require("Util"), b = [];
			c.each(d, function (e) {
				e && e.pName && b.push(e.pName);
			});
			b = a.unique(b);
			return require("Task").create(require("App").isInstall(b)).then(function (f) {
				var g = f.split(","), e = {};
				c.each(g, function (h, j) {
					e[b[j]] = h;
				});
				return e || {};
			});
		},
		getInstallAppids : function (b, c) {
			return require("Task").create(c || this.getInstallMap(b)).then(function (f) {
				var d = [], e = [];
				require("Util").each(b, function (g) {
					if (g && g.id) {
						var i = 1 == f[g.pName];
						i ? d.push(g.id) : e.push(g.id);
						var h = require("Download");
						h.updateProState(g.id, i ? h.PSTATE.INSTALL : h.PSTATE.UNINSTALL, true);
					}
				});
				e = a.unique(e);
				d = a.unique(d);
				return {
					appidsNotInstall : e,
					appidsInstalled : d
				};
			});
		},
		getApkIdByYyb : function (c) {
			var b = "";
			require("Util").each(c, function (d) {
				d.channel == "m_qq" && (b = d.apkId || "");
			});
			return b;
		}
	};
	return a;
});
define("Channel", {
	HOME : "1000",
	HOMESOCIAL : "3000",
	HOMEADV : "1003",
	HOMEREC : "2000",
	SEARCH : "1001",
	SEARCHRESULT : "1001_1",
	DETAIL : "1006",
	GUESS : "1022",
	GAME : "2100",
	HOTGAME : "2101",
	NEWGAME : "2102",
	GAMEADV : "2103",
	NOGAME : "2200",
	HOTNOGAME : "2201",
	NEWNOGAME : "2202",
	NOGAMEADV : "2203",
	MYAPP : "1004",
	UPDATE : "1011",
	MYAPPLIST : "2301",
	MYAPPLIST_NONE : "2301_1",
	MYAPPLIST_PC : "2301_2",
	MYAPPLIST_H5 : "2301_3",
	MYAPPLIST_NATIVE : "2301_4",
	UPDATELIST : "2302",
	UPDATELIST_NONE : "2302_1",
	NOTIFICATION : "2400",
	ALLAPPLIST : "2500",
	STORE_NEW : "2001",
	STORE_NORMAL : "2002",
	PCPUSH_2G3GDIALOG : "2459",
	_2G3GDIALOG : "2600",
	FREEGIFT : "1",
	BRAG : "52",
	PK : "53",
	INVITE : "100",
	PCPUSH_NOTIFY : "56",
	PCPUSH_AUTO : "57",
	ASSISTANT : "4000",
	GDTFEEDS : "10000"
});
define("Via", function () {
	var a = {
		pageVia : {
			1000 : ".STORE.HOME",
			2000 : ".STORE.HOME.RECOMMEND",
			3000 : ".STORE.HOME.SOCIAL",
			10000 : ".",
			1001 : ".STORE.SEARCH",
			"1001_1" : ".STORE.SEARCH.RESULT",
			1006 : ".STORE.APPDETAIL",
			1022 : ".STORE.APPDETAIL.GUESSLIST",
			2100 : ".STORE.GAMELIST",
			2101 : ".STORE.GAMELIST.HOT",
			2102 : ".STORE.GAMELIST.NEW",
			2200 : ".STORE.APPLIST",
			2201 : ".STORE.APPLIST.HOT",
			2202 : ".STORE.APPLIST.NEW",
			1004 : ".STORE.MYAPP",
			2301 : ".STORE.MYAPP.APPLIST",
			"2301_1" : ".STORE.MYAPP.APPLIST.NOAPP",
			"2301_2" : ".STORE.MYAPP.APPLIST.PCAPPLIST",
			"2301_3" : ".STORE.MYAPP.APPLIST.H5APPLIST",
			"2301_4" : ".STORE.MYAPP.APPLIST.NATIVEAPPLIST",
			2302 : ".STORE.MYAPP.UPDATELIST.APPLIST",
			"2302_1" : ".STORE.MYAPP.UPDATELIST.NOAPP",
			2410 : ".STORE.APPDETAIL.MIG",
			2500 : ".STORE.ALLAPPLIST",
			2001 : ".STORE.ASSISTANT.STORE.NEW",
			2002 : ".STORE.ASSISTANT.STORE.NORMAL"
		},
		channelVia : {
			1003 : ".STORE.APPDETAIL.HOME.ADS.",
			"1001_1" : ".STORE.APPDETAIL.SEARCH.RESULT",
			1004 : ".STORE.APPDETAIL.MYAPP.APPLIST",
			1011 : ".STORE.APPDETAIL.MYAPP.UPDATELIST",
			1022 : ".STORE.APPDETAIL.GUESSLIST",
			2000 : ".STORE.APPDETAIL.HOME.RECOMMEND",
			3000 : ".STORE.APPDETAIL.HOME.SOCIAL.",
			2101 : ".STORE.APPDETAIL.GAMELIST.HOT",
			2102 : ".STORE.APPDETAIL.GAMELIST.NEW",
			2103 : ".STORE.APPDETAIL.GAMELIST.ADS.",
			2201 : ".STORE.APPDETAIL.APPLIST.HOT",
			2202 : ".STORE.APPDETAIL.APPLIST.NEW",
			2203 : ".STORE.APPDETAIL.APPLIST.ADS.",
			"2301_1" : ".STORE.APPDETAIL.MYAPP.APPLIST.NOAPP",
			"2301_2" : ".STORE.APPDETAIL.MYAPP.APPLIST.PCAPPLIST",
			"2301_3" : ".STORE.APPDETAIL.MYAPP.APPLIST.H5APPLIST",
			"2301_4" : ".STORE.APPDETAIL.MYAPP.APPLIST.NATIVEAPPLIST",
			"2302_1" : ".STORE.APPDETAIL.MYAPP.UPDATELIST.NOAPP",
			2400 : ".STORE.APPDETAIL.DOWNLOADPUSH",
			2410 : ".STORE.APPDETAIL.MIG",
			2456 : ".STORE.APPDETAIL.PCPUSH",
			2457 : ".STORE.APPDETAIL.PCPUSH.AIOMSG",
			2458 : ".STORE.APPDETAIL.PCPUSH.MSGPUSH",
			2459 : ".STORE.APPDETAIL.PCPUSH.2G3GDIALOG",
			"2460_1" : ".FREEGIFT.APPAIO.APPDETAIL",
			"2460_50" : ".REQUEST.APPAIO.APPDETAIL",
			"2460_52" : ".BRAG.APPAIO.APPDETAIL",
			"2460_53" : ".PK.APPAIO.APPDETAIL",
			"2460_100" : ".INVITE.APPAIO.APPDETAIL",
			2500 : ".STORE.APPDETAIL.ALLLIST",
			2600 : ".STORE.2G3GDIALOG",
			1 : ".FREEGIFT.ASSISTANT.APPDETAIL",
			50 : ".REQUEST.ASSISTANT.APPDETAIL",
			52 : ".BRAG.ASSISTANT.APPDETAIL",
			53 : ".PK.ASSISTANT.APPDETAIL",
			56 : ".PCPUSH.NOTIFY.ASSISTANT.APPDETAIL",
			57 : ".PCPUSH.AUTO.ASSISTANT.APPDETAIL",
			58 : ".VOICE.ASSISTANT.APPDETAIL",
			100 : ".INVITE.ASSISTANT.APPDETAIL",
			"200_1" : ".SENDSTORY.FEED1.APPDETAIL",
			"200_2" : ".SENDSTORY.FEED2.APPDETAIL",
			"100_1" : ".INSTALL.FEED.APPDETAIL",
			"300_0" : ".STORE.ASSISTANT.STATEMSG.RECOMMEND.01",
			"300_1" : ".STORE.ASSISTANT.STATEMSG.RECOMMEND.02",
			"300_2" : ".STORE.ASSISTANT.STATEMSG.RECOMMEND.03",
			"300_3" : ".STORE.ASSISTANT.STATEMSG.RECOMMEND.04",
			"300_4" : ".STORE.ASSISTANT.STATEMSG.RECOMMEND.05",
			"300_5" : ".STORE.ASSISTANT.STATEMSG.RECOMMEND.06",
			"400_0" : ".STORE.ASSISTANT.STATENOMSG.RECOMMEND.01",
			"400_1" : ".STORE.ASSISTANT.STATENOMSG.RECOMMEND.02",
			"400_2" : ".STORE.ASSISTANT.STATENOMSG.RECOMMEND.03",
			"400_3" : ".STORE.ASSISTANT.STATENOMSG.RECOMMEND.04",
			"400_4" : ".STORE.ASSISTANT.STATENOMSG.RECOMMEND.05",
			"400_5" : ".STORE.ASSISTANT.STATENOMSG.RECOMMEND.06",
			10000 : ".",
			"-10000" : ".STORE.APPDETAIL.STARTERROR",
			"-100000" : ".STORE.APPDETAIL.UNKNOW"
		},
		channelExposureVia : {
			1 : ".STORE.APPDETAIL.FREEGIFT.ASSISTANT",
			50 : ".STORE.APPDETAIL.REQUEST.ASSISTANT",
			52 : ".STORE.APPDETAIL.BRAG.ASSISTANT",
			53 : ".STORE.APPDETAIL.PK.ASSISTANT",
			58 : ".STORE.APPDETAIL.VOICE.ASSISTANT",
			100 : ".STORE.APPDETAIL.INVITE.ASSISTANT",
			10000 : ".",
			"2460_1" : ".STORE.APPDETAIL.FREEGIFT.APPAIO",
			"2460_50" : ".STORE.APPDETAIL.REQUEST.APPAIO",
			"2460_52" : ".STORE.APPDETAIL.BRAG.APPAIO",
			"2460_53" : ".STORE.APPDETAIL.PK.APPAIO",
			"2460_100" : ".STORE.APPDETAIL.INVITE.APPAIO",
			2456 : ".STORE.APPDETAIL.PCPUSH",
			2457 : ".STORE.APPDETAIL.PCPUSH.AIOMSG",
			2458 : ".STORE.APPDETAIL.PCPUSH.MSGPUSH",
			"200_1" : ".STORE.APPDETAIL.SENDSTORY.FEED1",
			"200_2" : ".STORE.APPDETAIL.SENDSTORY.FEED2",
			"100_1" : ".STORE.APPDETAIL.INSTALL.FEED",
			"300_1" : ".STORE.APPDETAIL.RECOMMEND.01.ASSISTANT",
			"300_2" : ".STORE.APPDETAIL.RECOMMEND.02.ASSISTANT",
			"300_3" : ".STORE.APPDETAIL.RECOMMEND.03.ASSISTANT",
			"300_4" : ".STORE.APPDETAIL.RECOMMEND.04.ASSISTANT",
			"300_5" : ".STORE.APPDETAIL.RECOMMEND.05.ASSISTANT",
			"300_6" : ".STORE.APPDETAIL.RECOMMEND.06.ASSISTANT",
			"400_1" : ".STORE.APPDETAIL.RECOMMEND.01.ASSISTANT",
			"400_2" : ".STORE.APPDETAIL.RECOMMEND.02.ASSISTANT",
			"400_3" : ".STORE.APPDETAIL.RECOMMEND.03.ASSISTANT",
			"400_4" : ".STORE.APPDETAIL.RECOMMEND.04.ASSISTANT",
			"400_5" : ".STORE.APPDETAIL.RECOMMEND.05.ASSISTANT",
			"400_6" : ".STORE.APPDETAIL.RECOMMEND.06.ASSISTANT"
		},
		state : {
			DOWN : ".TODOWNLOAD",
			INSTALL : ".TOINSTALL",
			UPDATE : ".TOUPDATE",
			AUTOSTART : ".TOAUTOSTART",
			OPEN : ".TOOPEN"
		},
		getState : function (b) {
			return this.state[b];
		},
		setChannelAdId : function (b) {
			this.channelVia["1003"] += b;
			this.channelVia["2103"] += b;
			this.channelVia["2203"] += b;
		},
		setChannelSocialId : function (b) {
			this.channelVia["3000"] += b;
		},
		getPageVia : function (b) {
			var c = require("Const");
			if (require("Channel").ASSISTANT == c.channelId) {
				return this.getMsgVia(b);
			} else {
				return require("Task").create(require("Api").get("Platform")).then(function (d) {
					return d.toUpperCase() + a.pageVia[b || c.channelId];
				});
			}
		},
		getChannelVia : function (c, b, d, e) {
			var f = require("Const");
			return require("Task").create(require("Api").get("Platform")).then(function (g) {
				return g.toUpperCase() + ((b ? a.channelExposureVia[c || f.channelId] : null) || a.channelVia[c || f.channelId] || a.channelVia["-100000"]) + (e ? e : "") + (d ? d : "") + (b ? a.getState(b) : "");
			});
		},
		getReportVia : function (b, e) {
			var c = require("Channel"), d = Via.getPageVia(b == c.HOMESOCIAL || b == c.HOMEREC || b == c.SEARCHRESULT ? b : "") + (b == c.HOMESOCIAL ? "." + e : ""), f = Via.getChannelVia(b), g = Via.getMsgVia(b);
			return c.DETAIL == Const.channelId ? f : d != Api.getPlatform() ? d : g;
		},
		getMsgChannelVia : function (b) {
			var c = {
				1 : ".STORE.ASSISTANT.FREEGIFT.PUSH",
				50 : ".STORE.ASSISTANT.REQUEST.PUSH",
				52 : ".STORE.ASSISTANT.BRAG.PUSH",
				53 : ".STORE.ASSISTANT.PK.PUSH",
				56 : ".STORE.ASSISTANT.PCPUSH.NOTIFY.PUSH",
				57 : ".STORE.ASSISTANT.PCPUSH.AUTO.PUSH",
				58 : ".STORE.ASSISTANT.VOICE.PUSH",
				100 : ".STORE.ASSISTANT.INVITE.PUSH",
				2480 : ".STORE.ASSISTANT.MINIBOX",
				10000 : ".STORE.ASSISTANT.MYQZ",
				3001 : ".STORE.MSGCARDS"
			}[b] || "";
			return require("Task").create(require("Api").get("Platform")).then(function (d) {
				return d.toUpperCase() + c || "";
			});
		},
		getMsgVia : function (b) {
			var c = {
				1 : ".FREEGIFT.ASSISTANT",
				50 : ".REQUEST.ASSISTANT",
				52 : ".BRAG.ASSISTANT",
				53 : ".PK.ASSISTANT",
				56 : ".PCPUSH.NOTIFY.ASSISTANT",
				57 : ".PCPUSH.AUTO.ASSISTANT",
				58 : ".VOICE.ASSISTANT",
				100 : ".INVITE.ASSISTANT"
			}[b] || "";
			return require("Task").create(require("Api").get("Platform")).then(function (d) {
				return d.toUpperCase() + c || "";
			});
		}
	};
	return a;
});
define("MyNotify", function () {
	var a = {
		modified : function (d, e, f) {
			var g = 0, b = "", c = "";
			return require("Task").create(require("Api").get("Uin")).map(function (h) {
				var i = require("Storage");
				b = "notifylist_" + h, c = "notifyCount_" + h;
				return {
					uin : h,
					old : i.getItem(b),
					notify : d || i.getItem(require("Category").id.notify + h),
					currentFlag : i.getItem(c)
				};
			}).then(function (k) {
				var l = require("$"), p = require("Util"), q = require("Storage"), n = false, m = l.parseJSON(k.old) || {
					update : [],
					pcapp : []
				}, h = !require("Type").isString(k.notify) ? k.notify : l.parseJSON(k.notify) || {
					update : [],
					pcapp : []
				}, i = l.parseJSON(k.flagKey) || {
					update : 0,
					pcapp : 0
				}, j = {
					update : p.removeFromArray([].concat(h.update), [].concat(m.update)).length,
					pcapp : p.removeFromArray([].concat(h.pcapp), [].concat(m.pcapp)).length
				}, r = function (s) {
					s == e && f ? (i[s] = 0, j[s] = 0, n = true, m[s] = h[s]) : i[s] || j[s] ? i[s] = j[s] : i == 0 && diffCount == 0 && (i[s] = 0, j[s] = 0, n = true, m[s] = h[s]);
				};
				r("update");
				r("pcapp");
				q.setItem(c, l.stringify(i));
				n && q.setItem(b, l.stringify(m));
				return {
					pcappCount : j.pcapp != 0 ? h.pcapp.length : 0,
					updateCount : j.update != 0 ? h.update.length : 0
				};
			});
		}
	};
	return a;
});
